* PACKAGE DSETV !" ͊w 萔ݒ()
*
************************************************************************
      SUBROUTINE DSETV       !" ͊wp[g̒萔Zbg()
     O         ( SALPHA, SBETA , SKAPPA,
     O           ATF   , BTF   , TBAR  , TBARM ,
     O           GG    , TMTX  , WHMTX , GCMTX ,
     C           SIG   , SIGM  , DSIG            )
*
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" iq_Cg
      INCLUDE   (ZCCOM)                      !" W萔
#else
#include        "zcdim.F"                    !" iq_Cg
#include        "zccom.F"                    !" W萔
#endif
*
*   [OUTPUT] 
      REAL       SALPHA( KMAX )              !" Ð̎̌W
      REAL       SBETA ( KMAX )              !" Ð̎̌W
      REAL       SKAPPA( KMAX )              !" xԂ̌W
      REAL       ATF   ( KMAX )              !" xԂ̌W
      REAL       BTF   ( KMAX )              !" xԂ̌W
      REAL       TBAR  ( KMAX )              !" {xFx
      REAL       TBARM ( KMAX )              !" {xF
      REAL       GG    ( KMAX )              !" Z~CvVbgp
      REAL       TMTX  ( KMAX, KMAX )        !" Z~CvVbgp
      REAL       WHMTX ( KMAX, KMAX )        !" Z~CvVbgp
      REAL       GCMTX ( KMAX, KMAX )        !" Z~CvVbgp
*"       :  萔
*
      REAL       SIG   ( KMAX )              !" Ѓx()
      REAL       SIGM  ( KMAX+1 )            !" Ѓx()
      REAL       DSIG  ( KMAX )              !" 
*"       :  Wiq萔
*
*   [INTERNAL PARM] 
      REAL       TBAR0                       !" {x
      DATA       TBAR0 / 300.   /
*
*"         < 1. t@N^[ >
*
      CALL SETVDF
     O         ( SALPHA, SBETA , SKAPPA,
     O           ATF   , BTF   , TBAR  , TBARM ,
     C           SIG   , SIGM  , CP    , RAIR  ,
     I           TBAR0                           )
*
*"         < 2. semi-implicit s >
*
      CALL SETMTX
     O         ( GG    , TMTX  , WHMTX , GCMTX ,
     I           SALPHA, SBETA , SKAPPA,
     I           TBAR  , TBARM,
     C           SIGM  , DSIG  , CP             )
*
      RETURN
      END
***********************************************************************
      SUBROUTINE SETVDF      !" t@N^[
     O        ( SALPHA, SBETA , SKAPPA,
     O          ATF   , BTF   , TBAR  , TBARM ,
     I          SIG   , SIGM  , CP    , RAIR  ,
     I          TBAR0                            )
*
*"                 Arakawa & Suarez  ЍW
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)
#else
#include        "zcdim.F"
#endif
*
*   [OUTPUT] 
      REAL       SALPHA( KMAX )              !" Ð̎̌W 
      REAL       SBETA ( KMAX )              !" Ð̎̌W 
      REAL       SKAPPA( KMAX )              !" xԂ̌W
      REAL       ATF   ( KMAX )              !" xԂ̌W
      REAL       BTF   ( KMAX )              !" xԂ̌W
      REAL       TBAR  ( KMAX )              !" {xFx
      REAL       TBARM ( KMAX )              !" {xF
*
*   [INPUT] 
      REAL       SIG   ( KMAX )              !" Ѓx()
      REAL       SIGM  ( KMAX+1 )            !" Ѓx()
      REAL       CP                          !" C舳M
      REAL       RAIR                        !" CC̒萔
      REAL       TBAR0                       !" {x
*
*   [INTERNAL WORK] 
      REAL       AKAPPA                      !" q^b
      INTEGER    K
*
      AKAPPA = RAIR / CP
*
*"         < 1. Ð̎ >
*
      CALL HYDROS
     I   ( SIG   , SIGM  )
*
      CALL HYDROQ
     O   ( SALPHA, SBETA )
*
*"         < 2. CXx >
*
      DO 2100 K = 1, KMAX
         SKAPPA( K ) =  (    SIGM( K   ) * SALPHA( K )
     &                     + SIGM( K+1 ) * SBETA ( K )    )
     &                 /(    SIGM( K   ) - SIGM  ( K+1 )  )
 2100 CONTINUE
*
*"         < 3. x̕ >
*
      DO 3100 K = 2, KMAX
         ATF ( K ) =   SALPHA( K )
     &              / (   1. - ( SIG( K ) / SIG( K-1 ) )**AKAPPA   )
 3100 CONTINUE
*
      DO 3200 K = 1, KMAX-1
         BTF ( K ) =   SBETA ( K )
     &              / (   ( SIG( K ) / SIG( K+1 ) )**AKAPPA - 1.   )
 3200 CONTINUE
*
*"         < 4. {x >
*
      DO 4100 K = 1, KMAX
         TBAR  ( K ) = TBAR0
 4100 CONTINUE
*
      DO 4200 K = 2, KMAX
         TBARM ( K ) =   ATF ( K   ) * TBAR ( K   )
     &                 + BTF ( K-1 ) * TBAR ( K-1 )
 4200 CONTINUE
*
      RETURN
      END
***********************************************************************
      SUBROUTINE SETMTX          !" semi-implicit p̍s
     O         ( GG    , TMTX  , WHMTX , GCMTX ,
     I           SALPHA, SBETA , SKAPPA,
     I           TBAR  , TBARM ,
     I           SIGM  , DSIG  , CP             )
*
*"                 Arakawa & Suarez  ЍW
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)
#else
#include        "zcdim.F"
#endif
*
*   [OUTPUT] 
      REAL       GG    ( KMAX )              !" Z~CvVbgp
      REAL       TMTX  ( KMAX, KMAX )        !" Z~CvVbgp
      REAL       WHMTX ( KMAX, KMAX )        !" Z~CvVbgp
      REAL       GCMTX ( KMAX, KMAX )        !" Z~CvVbgp
*
*   [INPUT] 
      REAL       SALPHA( KMAX )              !" Ð̎̌W 
      REAL       SBETA ( KMAX )              !" Ð̎̌W 
      REAL       SKAPPA( KMAX )              !" xԂ̌W
      REAL       TBAR  ( KMAX )              !" {xFx
      REAL       TBARM ( KMAX )              !" {xF
      REAL       SIGM  ( KMAX+1 )            !" Ѓx()
      REAL       DSIG  ( KMAX )              !" 
      REAL       CP                          !" C舳M
*
*   [INTERNAL WORK] 
      COMMON    /COMWRK/
     &           WW    , SS    ,
     &           QQ    , RR
      REAL       WW    ( KMAX, KMAX )        !" v
      REAL       SS    ( KMAX, KMAX )        !" r
      REAL       QQ    ( KMAX, KMAX )        !" p
      REAL       RR    ( KMAX, KMAX )        !" q
*
      INTEGER    K, L, M
*
*"         < 0. b =  >
*
*"         < 1. f = bȂs >
*
      DO 1100 K = 1, KMAX
         GG ( K ) = CP * SKAPPA( K ) * TBAR( K )
 1100 CONTINUE
*
*"         < 2. v :  = v s >
*
      CALL RESET ( WW, KMAX*KMAX )
*
      DO 2120 K = 1, KMAX
*
         DO 2100 L = 1, K
            WW( K,L ) =             CP * SALPHA( L )
 2100   CONTINUE
*
         DO 2110 L = 1, K-1
            WW( K,L ) = WW( K,L ) + CP * SBETA( L )
 2110    CONTINUE
*
 2120 CONTINUE
*
*"         < 3. r F Ё^  r c >
*
      DO 3120 K = 1, KMAX
*
         DO 3100 L = 1, KMAX
            SS( K,L ) =   SIGM( K ) * DSIG( L )
 3100    CONTINUE
*
         DO 3110 L = K, KMAX
            SS( K,L ) =   SS( K,L ) - DSIG( L )
 3110    CONTINUE
*
 3120 CONTINUE
*
*"         < 4. p F Ё^ ݂s/݃  p r c >
*
      CALL RESET ( QQ, KMAX*KMAX )
*
      DO 4100 K = 1, KMAX
         QQ( K,K   ) = ( TBARM( K ) - TBAR ( K   ) ) / DSIG( K )
 4100 CONTINUE
*
      DO 4110 K = 1, KMAX-1
         QQ( K,K+1 ) = ( TBAR ( K ) - TBARM( K+1 ) ) / DSIG( K )
 4110 CONTINUE
*
*"         < 5. qFȂsi݃/݂{/^Ёj
*"                   q c >
*
      CALL RESET ( RR, KMAX*KMAX )
*
      DO 5120 K = 1, KMAX
*
         DO 5100 L = K, KMAX
            RR( K,L ) = - SALPHA( K ) / DSIG( K ) * DSIG( L )
     &                    * TBAR( K )
 5100    CONTINUE
*
         DO 5110 L = K+1, KMAX
            RR( K,L ) = RR( K,L )
     &                   - SBETA ( K ) / DSIG( K ) * DSIG( L )
     &                     * TBAR( K )
 5110    CONTINUE
*
 5120 CONTINUE
*
*"         < 6. p r >
*
      CALL RESET( TMTX, KMAX*KMAX )
*
      DO 6100 K = 1, KMAX
         DO 6100 L = 1, KMAX
            DO 6100 M = 1, KMAX
               TMTX( K,L ) = TMTX( K,L ) + QQ( K,M ) * SS( M,L )
 6100 CONTINUE
*
*"         < 7.   p r - q >
*
      DO 7100 K = 1, KMAX
         DO 7100 L = 1, KMAX
            TMTX( K,L ) = TMTX( K,L ) - RR( K,L )
 7100 CONTINUE
*
*"         < 8. v  >
*
      CALL RESET ( WHMTX, KMAX*KMAX )
*
      DO 8100 K = 1, KMAX
         DO 8100 L = 1, KMAX
            DO 8100 M = 1, KMAX
               WHMTX( K,L ) = WHMTX( K,L ) + WW( K,M ) * TMTX( M,L )
 8100 CONTINUE
*
*"         < 9. f tb  >
*
      DO 9100 K = 1, KMAX
         DO 9100 L = 1, KMAX
               GCMTX( K,L ) = GG( K ) * DSIG( L )
 9100 CONTINUE
*
      RETURN
      END
