* 1 p2cumk.F
* PACKAGE P2KUOC  !" ʪ(2) Kuoѥ᥿ꥼ
*
**********************************************************************
      SUBROUTINE CUMADJ        !" Kuoѥ᥿ꥼ
     M         ( GDT   , GDQ   ,
     M           GQPR  , GQCNV , GSCNV ,
     I           GDP   , GDPM  , GDZ   , DELTA  )
*
* 1 ..\include/zcdim.F
* PACKAGE  ZGT10L5 !"  ʻȿ
*
      INTEGER     IMAX           !" ٳʻҿ
      INTEGER     JMAX           !" ٳʻҿ
      INTEGER     IDIM           !" 󥵥
      INTEGER     JDIM           !" 󥵥
      INTEGER     MMAX           !" ȿ
      INTEGER     LMAX           !" ȿ
      INTEGER     NMAX           !" ȿ
      INTEGER     MINT           !" ȿֳ
      INTEGER     KMAX           !" ľؿ
      INTEGER     KDIM           !" ľ󥵥
      INTEGER     NMDIM          !" ʿȿʬ
      INTEGER     JMXHF          !" JMAX/2+1
      INTEGER     NWORK          !" ΰ礭
*
      PARAMETER ( IMAX  = 32,     JMAX = 16,
     &            IDIM  = IMAX+1, JDIM = JMAX,
     &            MMAX  = 10,     LMAX = 10,    NMAX = LMAX, MINT = 1,
     &            KMAX  =  5,     KDIM = KMAX,
     &            NMDIM = (MMAX/MINT+1)*(2*(NMAX+1)-MMAX)
     &                  - (NMAX-LMAX)/MINT*(NMAX-LMAX+1),
     &            JMXHF = JMAX/2+1,
     &            NWORK = IDIM*JDIM*KMAX*12                           )
* 1 ..\include/zccom.F
* 14 p2cumk.F
* PACKAGE ZHDIM  !" W萔(common)  
*
*"  [HIS]  90/08/31(numaguti)
*
      REAL       ER             !" na
      REAL       GRAV                        !" d͉x
      REAL       CP                          !" C舳M
      REAL       RAIR                        !" CC̒萔
      REAL       EL                          !" ̋Ì̐M
      REAL       CPVAP                       !" C舳M
      REAL       RVAP                        !" CC̒萔
      REAL       DH2O                        !" ̖x
      REAL       EPSV                        !" ƑC̕qʔ
      REAL       ES0                         !" OOaCFo
      REAL       STB                         !" Stefan-Boltzman
      REAL       FKARM                       !" Karman 萔
      REAL       EPSVT                       !" 1/-1
*
      COMMON   /COMCON/
     &          ER    , GRAV  ,
     &          CP    , RAIR  ,
     &          EL    , CPVAP , RVAP  , DH2O  , EPSV  , ES0   ,
     &          STB   , FKARM , EPSVT
* 15 p2cumk.F
*
*   [MODIFY] 
      REAL       GDT   ( IDIM*JDIM, KMAX )   !'   
      REAL       GDQ   ( IDIM*JDIM, KMAX )   !' 漾  
      REAL       GQPR  ( IDIM*JDIM       )   !' ߿
      REAL       GQCNV ( IDIM*JDIM, KMAX )   !' ŷĴǮΨ
      REAL       GSCNV ( IDIM*JDIM, KMAX )   !' ŷĴ漾Ѳ
*
*   [INPUT] 
      REAL       GDP   ( IDIM*JDIM, KMAX )   !'   
      REAL       GDPM  ( IDIM*JDIM, KMAX+1 ) !' Ⱦ
      REAL       GDZ   ( IDIM*JDIM, KMAX )   !' 
      REAL       DELTA                       !' 2t
*
*   [INTERNAL PARM] 
      REAL       QR0                         !' ѥ᡼
      REAL       QR1                         !' ѥ᡼
      DATA       QR0    / 0.80   /
      DATA       QR1    / 0.90   /
      NAMELIST  /NMKUOC/  QR0  , QR1
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE
*
*   [INTERNAL WORK]
      COMMON    /COMWRK/
     &           GDQOLD, GDTC  , GDQC  ,
     &           KBTM  , KTOP  ,
     &           QSUM  , QSSUM , QCONV ,
     &           DTSUM , DQSUM , BFAC  ,
     &           ADIAF , DELP  , GDQB
      REAL       GDQOLD( IDIM*JDIM, KMAX )   !' 漾θŤ
      REAL       GDTC  ( IDIM*JDIM, KMAX )   !' β
      REAL       GDQC  ( IDIM*JDIM, KMAX )   !' 漾
      INTEGER    KBTM  ( IDIM*JDIM )         !' ٥
      INTEGER    KTOP  ( IDIM*JDIM )         !' ĺ٥
      REAL       QSUM  ( IDIM*JDIM )         !' 漾ʬ
      REAL       QSSUM ( IDIM*JDIM )         !' ˰漾ʬ
      REAL       QCONV ( IDIM*JDIM )         !' «
      REAL       DTSUM ( IDIM*JDIM )         !' ٺʬ
      REAL       DQSUM ( IDIM*JDIM )         !' 漾ʬ
      REAL       BFAC  ( IDIM*JDIM )         !' ѥ᡼
      REAL       ADIAF ( IDIM*JDIM, KMAX )   !' Ǯ߲Ψ
      REAL       DELP  ( IDIM*JDIM, KMAX )   !' 
      REAL       GDQB  ( IDIM*JDIM, KMAX )   !' Ĵ漾
*
      INTEGER    IJ, K, IFPAR, JFPAR
      INTEGER    IREUSE
      REAL       ELF, QR, GMOIS, GHEAT
*
*   [INTERNAL FUNC] 
* 1 ..\include/zqsat.F
* PACKAGE ZQSAT     !" Clausis-Clapeyron ̎(֐)
*
*"    QSAT:  saturation water vapour mixing ratio
*"    DQSAT: d(QSAT)/d(T)
*
      REAL       FQSAT
      REAL       FDQSAT
      REAL       T, P, QS
*
      FQSAT ( T,P )    = EPSV * ES0
     &                   * EXP( EL/RVAP *( 1./273. - 1./T ) )
     &                   / P
      FDQSAT( T,QS )   = EL * QS / ( RVAP * T*T )
* 71 p2cumk.F
*
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' KUO CUMULUS PARAM. P2.2 DATE=91/01/12'
         OFIRST = .FALSE.
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMKUOC, END=390 )
  390    WRITE  ( JFPAR, NMKUOC )
      ENDIF
*
*"         < 1. ե׻ >
*
      DO 1100 K = 1, KMAX
         DO 1100 IJ = 1, IDIM*JDIM
            DELP  ( IJ,K ) = GDPM( IJ,K   ) - GDPM( IJ,K+1 )
 1100 CONTINUE
*
      ELF    = EL / CP
*
*"         < 2.  >
*
      CALL       LOADGQ
     O         ( GDQOLD )
*
      DO 2000 K = 1, KMAX
         DO 2000 IJ = 1, IDIM*JDIM
            GDQB ( IJ,K ) = GDQ ( IJ,K )
 2000 CONTINUE
*
      CALL RESET ( QSUM , IDIM*JDIM )
      CALL RESET ( QSSUM, IDIM*JDIM )
      CALL RESET ( QCONV, IDIM*JDIM )
      CALL RESET ( DTSUM, IDIM*JDIM )
      CALL RESET ( DQSUM, IDIM*JDIM )
*
*"         < 3. ؤΥå >
*
      IREUSE = 0
*
      CALL       CCLLEV
     O         ( GDTC  , GDQC  , KBTM  , KTOP  ,
     I           GDT   , GDQ   , GDP   , GDZ   ,
     I           IREUSE,
     W           ADIAF                          )
*
*"         < 4. μ«м >
*
      DO 4100 K = 1, KMAX
         DO 4110 IJ = 1, IDIM*JDIM
*
            IF (     ( KBTM( IJ ) .GT. 0   )
     &          .AND.( K .GE. KBTM( IJ )   )
     &          .AND.( K. LE. KTOP( IJ )   )  ) THEN
*
               QSUM ( IJ ) = QSUM ( IJ )
     &                        + GDQ ( IJ,K )
     &                         * DELP( IJ,K )
               QSSUM( IJ ) = QSSUM( IJ )
     &                        + FQSAT( GDT( IJ,K ), GDP( IJ,K ) )
     &                         * DELP( IJ,K )
               QCONV( IJ ) = QCONV( IJ )
     &                       + ( GDQ ( IJ,K )  - GDQOLD( IJ,K ) )
     &                         * DELP( IJ,K )
               DTSUM( IJ ) = DTSUM( IJ )
     &                       + ( GDTC( IJ,K ) - GDT( IJ,K ) )
     &                         * DELP( IJ,K )
               DQSUM( IJ ) = DQSUM( IJ )
     &                       + ( GDQC( IJ,K ) - GDQ( IJ,K ) )
     &                         * DELP( IJ,K )
*
            ENDIF
*
 4110    CONTINUE
 4100 CONTINUE
*
*"         < 5. ѥ᡼ >
*
      DO 5100 IJ = 1, IDIM*JDIM
         IF ( QSSUM( IJ ) .GT. 0. ) THEN
            QR         = QSUM( IJ ) / QSSUM( IJ )
            BFAC( IJ ) = 1. -  ( QR-QR0 )/( QR1-QR0 )
            BFAC( IJ ) = MAX( MIN( BFAC( IJ ),1.0 ), 0.0 )
         ENDIF
 5100 CONTINUE
*
*"         < 6. Ĵ >
*
      DO 6100 K = 1, KMAX
         DO 6110 IJ = 1, IDIM*JDIM
*
            IF (     ( QCONV( IJ ) .GT. 0.  )
     &          .AND.( KBTM( IJ )  .GT. 0   )
     &          .AND.( K .GE. KBTM( IJ )    )
     &          .AND.( K. LE. KTOP( IJ )    )  ) THEN
*
               GHEAT = ( 1. - BFAC( IJ ) ) * QCONV( IJ ) * ELF
     &                 * ( GDTC( IJ,K ) - GDT( IJ,K ) )
     &                 / DTSUM ( IJ )
*
               GMOIS = BFAC( IJ ) * QCONV( IJ )
     &                 * ( GDQC( IJ,K ) - GDQ( IJ,K ) )
     &                 / DQSUM ( IJ )
*
               GDT  ( IJ,K ) = GDT   ( IJ,K ) + GHEAT
               GDQ  ( IJ,K ) = GDQOLD( IJ,K ) + GMOIS
*
               GQCNV( IJ,K ) = GQCNV ( IJ,K )
     &                       + GHEAT / DELTA
*
               GSCNV( IJ,K ) = GSCNV ( IJ,K )
     &                       + ( GDQ( IJ,K ) - GDQB( IJ,K ) )/DELTA
*
               GQPR ( IJ )   = GQPR( IJ )
     &                       + GHEAT * CP / DELTA * DELP( IJ,K )/GRAV
*
            ENDIF
*
 6110    CONTINUE
 6100 CONTINUE
*
      RETURN
      END
