* 1 p2radi.F
* PACKAGE P2RADI   !" ʪ(2) ()
*
*" 90/10/09 ¸  
*"     92/04/17 ¸    
*"     92/08/27 ݹ
*"     98/01/22 ٹ  SAVEʸ˴ؤ
*"     99/07/07 ˭ıѻ  Ȥ
***********************************************************************
      SUBROUTINE SHTINS            !" 
     O         ( SINS  , SECZET ,
     I           IDATE ,
     C           ALON  , ALAT    )
*
*"   ŪᡦѲ(ץ)
*
*   [PARAM] 
* 1 ..\include/zcdim.F
* PACKAGE  ZGT10L5 !"  ʻȿ
*
      INTEGER     IMAX           !" ٳʻҿ
      INTEGER     JMAX           !" ٳʻҿ
      INTEGER     IDIM           !" 󥵥
      INTEGER     JDIM           !" 󥵥
      INTEGER     MMAX           !" ȿ
      INTEGER     LMAX           !" ȿ
      INTEGER     NMAX           !" ȿ
      INTEGER     MINT           !" ȿֳ
      INTEGER     KMAX           !" ľؿ
      INTEGER     KDIM           !" ľ󥵥
      INTEGER     NMDIM          !" ʿȿʬ
      INTEGER     JMXHF          !" JMAX/2+1
      INTEGER     NWORK          !" ΰ礭
*
      PARAMETER ( IMAX  = 32,     JMAX = 16,
     &            IDIM  = IMAX+1, JDIM = JMAX,
     &            MMAX  = 10,     LMAX = 10,    NMAX = LMAX, MINT = 1,
     &            KMAX  =  5,     KDIM = KMAX,
     &            NMDIM = (MMAX/MINT+1)*(2*(NMAX+1)-MMAX)
     &                  - (NMAX-LMAX)/MINT*(NMAX-LMAX+1),
     &            JMXHF = JMAX/2+1,
     &            NWORK = IDIM*JDIM*KMAX*12                           )
* 21 p2radi.F
*
*   [OUTPUT] 
      REAL       SINS  ( IDIM, JDIM )        !" ͥեå
      REAL       SECZET( IDIM, JDIM )        !" sec(ͳ)
*
*   [INPUT] 
      INTEGER    IDATE ( 6 )                 !" 
      REAL       ALON  ( IDIM )              !" 
      REAL       ALAT  ( JDIM )              !" 
*
*   [INTERNAL PARM] 
      REAL       SOLCON
      LOGICAL    OYRAVR, ODYAVR
      REAL       ATALB
      REAL       EPSORB, EQNORB
      REAL       AINS, BINS
      REAL       AZET, BZET
      DATA       SOLCON     / 1380.   /      !" 
      DATA       OYRAVR     / .TRUE. /       !" ǯʿͥե饰
      DATA       ODYAVR     / .TRUE. /       !" ʿͥե饰
      DATA       ATALB      / 0.2     /      !" 絤٥
      DATA       EPSORB     / 23.5    /      !" ƻг
      DATA       EQNORB     / 110.    /      !" 
      DATA       AINS       / 0.127   /      !" ǯʿͤη
      DATA       BINS       / 0.183   /      !" ǯʿͤη
      DATA       AZET       / 0.410   /      !" ǯʿͳѤη
      DATA       BZET       / 0.590   /      !" ǯʿͳѤη
*
      NAMELIST  /NMRADI/ SOLCON, OYRAVR, ODYAVR, ATALB ,
     &                   EPSORB, EQNORB , 
     &                   AINS  , BINS  , AZET  , BZET
      SAVE	! Ƥѿ SAVE
*
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
*     SAVE       OFIRST			! SAVE Ϥ⤦Ƥ뤫Բ
*
*   [INTERNAL WORK] 
      REAL       RDATE ( 2 )                 !" , 
*
      INTEGER    I, J
      INTEGER    IFPAR, JFPAR
      REAL       PI, COSZET, ANGHR, SINDEL
*      
*   [ONCE] 
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' SOLAR INSOLATION  P2.2 DATE=92/04/17'
         OFIRST = .FALSE.
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMRADI, END=190 )
  190    WRITE  ( JFPAR, NMRADI )
      ENDIF
*
*"          < 0. , 򾮿 >
*
      CALL RDATES
     O      ( RDATE ,
     I        IDATE  )
*
      PI = ATAN( 1. ) *4.
*
      IF ( OYRAVR .AND. ODYAVR ) THEN
*
*"           < 1. ǯʿ >
*
         DO 1100 I = 1, IDIM
            DO 1110 J = 1, JDIM
               SINS( I,J ) = - SOLCON * ( 1. - ATALB )
     &                         * ( AINS + BINS*COS( ALAT(J) )**2 )
*
               IF ( SINS( I,J ) .LT. 0. ) THEN
                  SECZET( I,J ) = 1.  /( AZET + BZET*COS( ALAT(J) )**2 )
               ELSE
                  SINS  ( I,J ) = 0.  
                  SECZET( I,J ) = 0.  
               ENDIF
 1110       CONTINUE
 1100    CONTINUE
*
      ELSE IF ( (.NOT.OYRAVR).AND.(.NOT.ODYAVR) ) THEN
*
*"          < 2. ᡦѲ >  
*"                   92/08/27 bug-fixed by takepiro <-- 

         SINDEL =  SIN( EPSORB/180.* PI  )
     &           * SIN( ( RDATE( 1 ) - EQNORB/360. )*2.*PI ) 
*
         DO 2100 I = 1, IDIM
            DO 2110 J = 1, JDIM
               ANGHR  = RDATE( 2 )*2.*PI - PI + ALON( I ) 
               COSZET = SIN( ALAT(J) )*SINDEL
     &                + COS( ALAT(J) )*SQRT(1.-SINDEL**2)*COS( ANGHR )
*
               IF ( COSZET .GT. 0. ) THEN
                  SINS  ( I,J ) = - SOLCON * ( 1. - ATALB ) * COSZET
                  SECZET( I,J ) = 1. / COSZET
               ELSE
                  SINS  ( I,J ) = 0.  
                  SECZET( I,J ) = 0.  
               ENDIF
 2110       CONTINUE
 2100    CONTINUE
*
*"                                                  <--- ޤ
*
      ELSE
*
         CALL MSGDMP( 'E', 'SHTINS',
     &                'THIS TYPE OF INSOLATION IS NOT IMPREMENTED' ) 
*
      ENDIF
*
      RETURN
      END


