* 1 p2shlt.F
* PACKAGE P2SHLT  !" ʪ(2) ѱή(Tiedtke)
*
***********************************************************************
      SUBROUTINE SHLCOF !" ѱήȻ , Tiedtke
     M         ( DFM   , DFH   , DFE   ,
     I           GDT   , GDQ   , GDP   , GDZ   ,
     W           GDTC  , GDQC  , ADIAF ,
     W           KBTM  , KTOP                   )
*
*   [PARAM] 
* 1 ..\include/zcdim.F
* PACKAGE  ZGT10L5 !"  ʻȿ
*
      INTEGER     IMAX           !" ٳʻҿ
      INTEGER     JMAX           !" ٳʻҿ
      INTEGER     IDIM           !" 󥵥
      INTEGER     JDIM           !" 󥵥
      INTEGER     MMAX           !" ȿ
      INTEGER     LMAX           !" ȿ
      INTEGER     NMAX           !" ȿ
      INTEGER     MINT           !" ȿֳ
      INTEGER     KMAX           !" ľؿ
      INTEGER     KDIM           !" ľ󥵥
      INTEGER     NMDIM          !" ʿȿʬ
      INTEGER     JMXHF          !" JMAX/2+1
      INTEGER     NWORK          !" ΰ礭
*
      PARAMETER ( IMAX  = 32,     JMAX = 16,
     &            IDIM  = IMAX+1, JDIM = JMAX,
     &            MMAX  = 10,     LMAX = 10,    NMAX = LMAX, MINT = 1,
     &            KMAX  =  5,     KDIM = KMAX,
     &            NMDIM = (MMAX/MINT+1)*(2*(NMAX+1)-MMAX)
     &                  - (NMAX-LMAX)/MINT*(NMAX-LMAX+1),
     &            JMXHF = JMAX/2+1,
     &            NWORK = IDIM*JDIM*KMAX*12                           )
* 1 ..\include/zccom.F
* 16 p2shlt.F
* PACKAGE ZHDIM  !" W萔(common)  
*
*"  [HIS]  90/08/31(numaguti)
*
      REAL       ER             !" na
      REAL       GRAV                        !" d͉x
      REAL       CP                          !" C舳M
      REAL       RAIR                        !" CC̒萔
      REAL       EL                          !" ̋Ì̐M
      REAL       CPVAP                       !" C舳M
      REAL       RVAP                        !" CC̒萔
      REAL       DH2O                        !" ̖x
      REAL       EPSV                        !" ƑC̕qʔ
      REAL       ES0                         !" OOaCFo
      REAL       STB                         !" Stefan-Boltzman
      REAL       FKARM                       !" Karman 萔
      REAL       EPSVT                       !" 1/-1
*
      COMMON   /COMCON/
     &          ER    , GRAV  ,
     &          CP    , RAIR  ,
     &          EL    , CPVAP , RVAP  , DH2O  , EPSV  , ES0   ,
     &          STB   , FKARM , EPSVT
* 17 p2shlt.F
*
*   [MODIFY] 
      REAL       DFM   ( IDIM*JDIM, KMAX+1 ) !" ͢
      REAL       DFH   ( IDIM*JDIM, KMAX+1 ) !" ͢
      REAL       DFE   ( IDIM*JDIM, KMAX+1 ) !" ͢
*
*   [INPUT] 
      REAL       GDT   ( IDIM*JDIM, KMAX )   !"   
      REAL       GDQ   ( IDIM*JDIM, KMAX )   !" 漾  
      REAL       GDP   ( IDIM*JDIM, KMAX )   !"   
      REAL       GDZ   ( IDIM*JDIM, KMAX )   !"    
*
*   [WORK] 
      REAL       GDTC  ( IDIM*JDIM, KMAX )   !" β
      REAL       GDQC  ( IDIM*JDIM, KMAX )   !" 漾
      REAL       ADIAF ( IDIM*JDIM, KMAX )   !" Ǯ߲Ψ
      INTEGER    KBTM  ( IDIM*JDIM )         !" ٥
      INTEGER    KTOP  ( IDIM*JDIM )         !" ĺ٥
*
*   [INTERNAL PARM] 
      REAL       DFMSHL
      REAL       DFHSHL
      REAL       DFESHL
      REAL       PTOPMN
      REAL       RCRIT
      DATA       DFMSHL /    10.   /         !" ԳȻ
      DATA       DFHSHL /    10.   /         !" ԳȻ
      DATA       DFESHL /    10.   /         !" Ȼ
      DATA       PTOPMN /   750.   /         !" ĺǾ
      DATA       RCRIT  /   0.50   /         !" мٺǾ
*
      NAMELIST  /NMSHLT/ DFMSHL, DFHSHL, DFESHL, PTOPMN, RCRIT
*
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE
*
*   [INTERNAL WORK] 
      INTEGER    IFPAR, JFPAR, IREUSE
      INTEGER    IJ, K
      REAL       PTMIN, QSAT
*
* 1 ..\include/zqsat.F
* PACKAGE ZQSAT     !" Clausis-Clapeyron ̎(֐)
*
*"    QSAT:  saturation water vapour mixing ratio
*"    DQSAT: d(QSAT)/d(T)
*
      REAL       FQSAT
      REAL       FDQSAT
      REAL       T, P, QS
*
      FQSAT ( T,P )    = EPSV * ES0
     &                   * EXP( EL/RVAP *( 1./273. - 1./T ) )
     &                   / P
      FDQSAT( T,QS )   = EL * QS / ( RVAP * T*T )
* 64 p2shlt.F
*
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' SHALLOW CONVECTION TIEDTKE P2.1 DATE=91/01/09'
         OFIRST = .FALSE.
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMSHLT, END=1190 )
 1190    WRITE  ( JFPAR, NMSHLT )
*
         PTMIN  = PTOPMN * 100.  
      ENDIF
*
*"         < 1. ؤΥå >
*
      IREUSE = 1
*
      CALL       CCLLEV
     O         ( GDTC  , GDQC  , KBTM  , KTOP  ,
     I           GDT   , GDQ   , GDP   , GDZ   ,
     I           IREUSE,
     W           ADIAF                           )
*
*"         < 2. Ȼν >
*
      DO 2100 K = 2, KMAX
         DO 2110 IJ = 1, IDIM*JDIM
*
            IF ( KBTM( IJ ) .GT. 0 ) THEN
               IF (     ( GDP( IJ,KTOP(IJ) ) .GT. PTMIN )
     &             .AND.( K .GE. KBTM( IJ ) )
     &             .AND.( K .LE. KTOP( IJ ) )            ) THEN
*
                  QSAT = FQSAT( GDT( IJ,K ), GDP( IJ,K ) )
                  IF ( GDQ( IJ,K )/QSAT .GE. RCRIT ) THEN
                     DFM( IJ,K ) = DFM( IJ,K ) + DFMSHL
                     DFH( IJ,K ) = DFH( IJ,K ) + DFHSHL
                     DFE( IJ,K ) = DFE( IJ,K ) + DFESHL
                  ENDIF
*
               ENDIF
            ENDIF
*
 2110    CONTINUE
 2100 CONTINUE
*
      RETURN
      END
