* PACKAGE A1DIM      !" 1C
*
*"  [HIS] 90/08/31(numaguti)
*
***********************************************************************
      PROGRAM GCM1D     !" ꎟeXgf
*
*
*"       << ꎟf >>
*
*"                 Version 0.50              90/08/24 (   )
*
*   [PARAM] 
#if   HITAC
      INCLUDE   (ZCDIM)
      INCLUDE   (ZHDIM)
      INCLUDE   (ZCCOM)                      !" W萔
#else
#include        "zcdim.F"
#include        "zhdim.F"
#include        "zccom.F"                    !" W萔
#endif
*
*"  [VAR]
      REAL       GBU   ( IDIM, JDIM, KMAX )  !"   
      REAL       GBV   ( IDIM, JDIM, KMAX )  !" 앗  
      REAL       GBT   ( IDIM, JDIM, KMAX )  !" x  s
      REAL       GBPS  ( IDIM, JDIM       )  !" n\C
      REAL       GBQ   ( IDIM, JDIM, KMAX )  !" 䎼  
      REAL       GBVOR ( IDIM, JDIM, KMAX )  !" Qx  
      REAL       GBDIV ( IDIM, JDIM, KMAX )  !" U  c
      REAL       GBTG  ( IDIM, JDIM )        !" nʉxs
*"       : iq_f[^
*
      REAL       GTUA  ( IDIM, JDIM, KMAX )  !" ^ʕωt`
      REAL       GTVA  ( IDIM, JDIM, KMAX )  !" k^ʕωu`
      REAL       GTH   ( IDIM, JDIM, KMAX )  !" xԕω  g
      REAL       GTR   ( IDIM, JDIM, KMAX )  !" 䎼ԕω  q
      REAL       GTTG  ( IDIM, JDIM )        !" n\xω
*"       : iq_ԕω
*
      INTEGER    ISTEP                       !" ʂXebv
      INTEGER    ITA                         !" ʂ(t)
      INTEGER    ITB                         !" ʂ(t-t)
      INTEGER    IDATEA( 6 )                 !" FNb
      INTEGER    IDATEB( 6 )                 !" FNb
      REAL       DELT                        !" ԍ݃t
      LOGICAL    OADVNC                      !" is邩ۂ
      LOGICAL    ORSTR                       !" ďoo͂邩ۂ
*"        : ϐ
*
      DATA       ISTEP        / 0  /
      DATA       ITA, ITB     / 0 , 0 /
*
*   [INTERNAL PARM] 
      INTEGER    IDATEI ( 6 )
      DATA       IDATEI       / 1992, 1, 1, 0, 0, 0 /
      NAMELIST   / NMDATE / IDATEI 
*
      INTEGER    ITSTRT                      !" vZJn
      INTEGER    ITEND                       !" vZI
      INTEGER    IORSTR                      !" o͊ԊuFďo
*
      INTEGER    IDELT                       !" Wԍ
      INTEGER    INISTP                      !" Xebv
      REAL       TFIL                        !" ԃtB^[W
*
*"    COMMON /COMCON/ ( include ZCCOM )
*     REAL       CP                          !" C舳M
*     REAL       EL                          !" ̋Ì̐M
*     REAL       ER                          !" na
*     REAL       GRAV                        !" d͉x
*     REAL       RAIR                        !" CC̒萔
*     REAL       RVAP                        !" CC̒萔
*     REAL       CPVAP                       !" C舳M
*     REAL       DH2O                        !" ̖x
*     REAL       EPSV                        !" ƑC̕qʔ
*     REAL       ES0                         !" OOaC
*     REAL       STB                         !" Stefan-Boltzman
*"    COMMON /COMCON/ end
*
*   [INTERNAL WORK] 
      REAL       ALAT  ( JDIM )              !" ܓx
      REAL       DLAT  ( JDIM )              !" ܓx׏d
      REAL       ALON  ( IDIM )              !" ox
      REAL       DLON  ( IDIM )              !" ox׏d
*
      REAL       SIG   ( KMAX )              !" Ѓx()
      REAL       SIGM  (KMAX+1)              !" Ѓx()
      REAL       DSIG  ( KMAX )              !" ()
      REAL       DSIGM (KMAX+1)              !" ()
*
      REAL       CORIOL( JDIM )              !" RIW 
      REAL       GGU   ( IDIM, JDIM, KMAX )  !" nt g
*
      REAL       PI, OMEGA
      INTEGER    IFPAR, JFPAR, IERR
      INTEGER    I, J, K, II
*
*   [WORK] 
      COMMON    /COMWRK/ WORK
      REAL       WORK  ( NWORK )             !" [N̈
*
      CALL YPREP
*
*"           <<<<<<<<<<<<< ݒ >>>>>>>>>>>>>>
*
*
*"         < 1. p[^[̃Zbg >
*
      OPEN     ( 1, FILE='PARM1D', IOSTAT=IERR,
     &           FORM='FORMATTED',
     &           ACCESS='SEQUENTIAL'                 )
      CALL       SETNML ( 1, 6 )
*
      CALL       SETPAR
     O         ( ITSTRT, ITEND , IORSTR,
     O           IDELT , INISTP, TFIL            )
*
      CALL PCONST
*
*"         < 2. fW萔̌vZ >
*
      CALL SETCOR
     O         ( ALON  , DLON  ,
     O           ALAT  , DLAT  ,
     O           SIG   , DSIG  ,
     O           SIGM  , DSIGM  )
*
      PI    = ATAN2 ( 0.  , -1. )
      OMEGA = 2.   * PI / 86400.
      DO 200 J = 1, JDIM
         CORIOL ( J ) = 2. * OMEGA * SIN( ALAT(J) )
  200 CONTINUE
*
*"         < 5. l̐ >
*
      CALL   REWNML ( IFPAR , JFPAR )
      READ   ( IFPAR, NMDATE, END=480 )
 480  WRITE  ( JFPAR, NMDATE )
      DO 490 II = 1, 6
         IDATEA( II ) = IDATEI( II )
         IDATEB( II ) = IDATEI( II )
 490  CONTINUE
*
      DO 500 K = 1, KMAX
         DO 500 J = 1, JDIM
            DO 500 I = 1, IDIM
               GGU  ( I,J,K ) = 20.  *(1.5-SIG(K))
               GBU  ( I,J,K ) = GGU ( I,J,K )
               GBV  ( I,J,K ) = 0.
               GBVOR( I,J,K ) = 0.
               GBDIV( I,J,K ) = 0.
               GBT  ( I,J,K ) = 200. + SIG(K) * 100.
               GBQ  ( I,J,K ) = 1.E-5
  500 CONTINUE
      DO 510 J = 1, JDIM
         DO 510 I = 1, IDIM
               GBPS( I,J ) = 1000.  
               GBTG( I,J ) = GBT ( I,J,1 )
  510 CONTINUE
*
      WRITE ( 6,* ) ' ###### START ######## ', IMAX, JMAX, KMAX
 5000 CONTINUE
*"                                               <===== repeat MAIN ===
*
*"         <<<<<<<<< CE[vn܂ >>>>>>>>
*
         ISTEP = ISTEP + 1
*
*"         < 6 Ԑ >
*
         CALL TIMSTP
     O         ( DELT  , OADVNC, ORSTR ,
     I           ITA   , ITB   , IDATEA, IDATEB, ISTEP  ,
     C           IDELT , INISTP, ITEND , IORSTR          )
*
         CALL SAVEGQ
     I         ( GBQ   )
*
*"         < 7. ߒ >
*
         CALL PHYSCS
     O         ( GTUA  , GTVA  , GTH   , GTR   , GTTG  ,
     I           GBU   , GBV   , GBT   , GBPS  , GBQ   ,
     I           GBVOR , GBDIV , GBTG  ,
     I           ITB   , IDATEB, DELT  ,
     C           ALON  , ALAT  ,
     C           SIG   , SIGM  , DSIG  , DSIGM          )
*
*"                < 6.2 nʉx̐ϕ >
*
         CALL TGINTG
     M         ( GBTG  ,
     I           GTTG  , DELT  )
*
*"         < 8. ͊wߒ >
*
         DO 800 K = 1, KMAX
            DO 800 J = 1, JDIM
               DO 800 I = 1, IDIM
                  GBU  ( I,J,K ) = GBU ( I,J,K )
     &                           + GTUA( I,J,K ) * DELT
     &                           + GBV ( I,J,K )
     &                              * CORIOL ( J ) * DELT
*
                  GBV  ( I,J,K ) = GBV ( I,J,K )
     &                           + GTVA( I,J,K ) * DELT
     &                           + ( GGU ( I,J,K ) - GBU  ( I,J,K ) )
     &                              * CORIOL ( J ) * DELT
*
                  GBT  ( I,J,K ) = GBT ( I,J,K )
     &                           + GTH ( I,J,K ) * DELT
*
                  GBQ  ( I,J,K ) = GBQ ( I,J,K )
     &                           + GTR ( I,J,K ) * DELT
  800    CONTINUE
*
         CALL PADJST
     M         ( GBU   , GBV   , GBT   , GBPS  , GBQ   ,
     I           GBVOR , GBDIV ,
     I           DELT  ,
     C           SIG   , SIGM  , DSIG  , DSIGM          )
*
         CALL   DIAGP ( GBU   , 'U'   , KMAX  , '(F12.3)'  )
         CALL   DIAGP ( GBV   , 'V'   , KMAX  , '(F12.3)'  )
         CALL   DIAGP ( GBT   , 'T'   , KMAX  , '(F12.3)'  )
         CALL   DIAGP ( GBQ   , 'Q'   , KMAX  , '(3PF12.3)')
         CALL   DIAGP ( GBTG  , 'TG'  , 1     , '(F12.3)'  )
*
         CALL    ADVSTP
     O         ( ITA   , ITB   , IDATEA, IDATEB,
     I           OADVNC                          )
*
      IF ( ITB .LT. ITEND ) GOTO 5000
*
*"          <<<<<<<< CE[vI >>>>>>>>
*
*"                                               =====> until MAIN ===>
      CALL YFINE
*
      STOP
      END
************************************************************************
      SUBROUTINE RDCON
     O         ( GDATA , ITNEXT,
     I           HFILE , HITEM , DEFVAL , HCORD , ITSEL  )
*
*   [PARAM] 
#if   HITAC
      INCLUDE   (ZCDIM)                      !" iq_Cg
#elif SX3
      INCLUDE   "zcdim.F"                    !" iq_Cg
#else
#include        "zcdim.F"                    !" iq_Cg
#endif
*
*   [OUTPUT] 
      REAL       GDATA ( * )                 !" f[^
      INTEGER    ITNEXT
*
*   [INPUT] 
      CHARACTER  HFILE *(*)                  !" t@C
      CHARACTER  HITEM *(*)                  !" ʖ
      REAL       DEFVAL                      !" ftHgl
      CHARACTER  HCORD *(*)                  !" W
      INTEGER    ITSEL
*
*   [INTERNAL PARM] 
      INTEGER    ILARGE
      DATA       ILARGE / 2147483647 /       !" ől
*
*   [INTERNAL WORK] 
      INTEGER    KDIMD, NDIMD
*
      IF      ( HCORD .EQ. 'ALEV' ) THEN
         KDIMD = KMAX
      ELSE IF ( HCORD .EQ. 'AMLEV' ) THEN
         KDIMD = KMAX+1
      ELSE
         KDIMD = 1
      ENDIF
      NDIMD = IDIM * JDIM * KDIMD
*
      CALL  SETV ( GDATA, DEFVAL, NDIMD  )
*
      ITNEXT = ILARGE
*
      RETURN
      END
************************************************************************
      SUBROUTINE HISTIN
     I         ( GDATA ,
     C           HITEM  )
*
*"          << _~[ >>
*
*   [INPUT] 
      REAL       GDATA
      CHARACTER  HITEM *(*)
*
      RETURN
      END
************************************************************************
      SUBROUTINE HISTRG
     I         ( HITEM , HTITL , HUNIT , HCORD ,
     I           DMINX , DMAXX , DIVSX , DIVLX , ISTYPX,
     I           FILEM , TUNITM, INTOUM, INTSMM, AVRTYM, DFORMM )
*
*"          << _~[ >>
*
      CHARACTER  HITEM *(*), HTITL *(*), HUNIT *(*), HCORD *(*)
      REAL       DMINX, DMAXX, DIVSX, DIVLX
      INTEGER    ISTYPX
      CHARACTER  FILEM *(*), TUNITM*(*)
      INTEGER    INTOUM, INTSMM
      CHARACTER  AVRTYM*(*), DFORMM*(*)
*
      RETURN
      END
************************************************************************
      SUBROUTINE SAVEGQ
     I         ( GBQ    )
*
#if   HITAC
      INCLUDE   (ZCDIM)                      !" iq_, g
#else
#include        "zcdim.F"                    !" iq_, g
#endif
*
*   [INPUT] 
      REAL       GBQ   ( IDIM*JDIM*KMAX )    !" 䎼  (t-t)
*
*   [INTERNAL SAVE] 
      REAL       GBBQ  ( IDIM*JDIM*KMAX )    !" 䎼   Z[ul
      SAVE
*
      CALL COPY ( GBBQ  , GBQ   , IDIM*JDIM*KMAX )
*
      RETURN
*======================================================================
      ENTRY      LOADGQ
     O         ( GBQ    )
*
      CALL COPY ( GBQ   , GBBQ  , IDIM*JDIM*KMAX )
*
      RETURN
      END
***********************************************************************
      SUBROUTINE GAUSS
     O         ( QSINLA , QGW    ,
     I           JMAX             )
*
*"          << _~[ >>
*
      INTEGER    JMAX
      REAL       QSINLA
      REAL       QGW

      RETURN
      END
***********************************************************************
      SUBROUTINE IFLOPN
     O         ( IFILE , IERR  ,
     I           HFILE , IFILED, HACT  , HFORM   )
*
*   [OUTPUT] 
      INTEGER    IFILE
      INTEGER    IERR
*
*   [INPUT] 
      CHARACTER  HFILE *(*)
      INTEGER    IFILED
      CHARACTER  HACT  *(*)
      CHARACTER  HFORM *(*)
*
      IFILE = 6
      IERR  = 0
*
      RETURN
      END
