* 1 dhydr.F
* PACKAGE DHYDR       !" ͊w Ð GCM5(DHYDR)
*
***********************************************************************
      SUBROUTINE WHYDRO     !" Ð̎ ( XyNg )
     O         ( WDPHI ,
     I           WDT    )
*
*"                 Arakawa & Suarez  ЍW
*
*   [PARAM] 
* 1 ..\include/zcdim.F
* PACKAGE  ZGT10L5 !"  ʻȿ
*
      INTEGER     IMAX           !" ٳʻҿ
      INTEGER     JMAX           !" ٳʻҿ
      INTEGER     IDIM           !" 󥵥
      INTEGER     JDIM           !" 󥵥
      INTEGER     MMAX           !" ȿ
      INTEGER     LMAX           !" ȿ
      INTEGER     NMAX           !" ȿ
      INTEGER     MINT           !" ȿֳ
      INTEGER     KMAX           !" ľؿ
      INTEGER     KDIM           !" ľ󥵥
      INTEGER     NMDIM          !" ʿȿʬ
      INTEGER     JMXHF          !" JMAX/2+1
      INTEGER     NWORK          !" ΰ礭
*
      PARAMETER ( IMAX  = 32,     JMAX = 16,
     &            IDIM  = IMAX+1, JDIM = JMAX,
     &            MMAX  = 10,     LMAX = 10,    NMAX = LMAX, MINT = 1,
     &            KMAX  =  5,     KDIM = KMAX,
     &            NMDIM = (MMAX/MINT+1)*(2*(NMAX+1)-MMAX)
     &                  - (NMAX-LMAX)/MINT*(NMAX-LMAX+1),
     &            JMXHF = JMAX/2+1,
     &            NWORK = IDIM*JDIM*KMAX*12                           )
* 1 ..\include/zccom.F
* 16 dhydr.F
* PACKAGE ZHDIM  !" W萔(common)  
*
*"  [HIS]  90/08/31(numaguti)
*
      REAL       ER             !" na
      REAL       GRAV                        !" d͉x
      REAL       CP                          !" C舳M
      REAL       RAIR                        !" CC̒萔
      REAL       EL                          !" ̋Ì̐M
      REAL       CPVAP                       !" C舳M
      REAL       RVAP                        !" CC̒萔
      REAL       DH2O                        !" ̖x
      REAL       EPSV                        !" ƑC̕qʔ
      REAL       ES0                         !" OOaCFo
      REAL       STB                         !" Stefan-Boltzman
      REAL       FKARM                       !" Karman 萔
      REAL       EPSVT                       !" 1/-1
*
      COMMON   /COMCON/
     &          ER    , GRAV  ,
     &          CP    , RAIR  ,
     &          EL    , CPVAP , RVAP  , DH2O  , EPSV  , ES0   ,
     &          STB   , FKARM , EPSVT
* 17 dhydr.F
*
*   [OUTPUT] 
      REAL       WDPHI ( NMDIM, KMAX )       !" x  
      REAL       WDT   ( NMDIM , KMAX     )  !" x  s
*
*   [INPUT] 
      REAL       GDPHI ( IDIM*JDIM, KMAX )   !" x  
      REAL       GDT   ( IDIM*JDIM, KMAX )   !" x  s
*
      REAL       SALPHA( KMAX )              !" Ð̎̌W 
      REAL       SBETA ( KMAX )              !" Ð̎̌W 
*
*   [ENTRY INPUT] 
      REAL       SIG   ( KMAX )              !" Ѓx()
      REAL       SIGM  ( KMAX+1 )            !" Ѓx()
*
*   [INTERNAL SAVE] 
      REAL       SALPHZ( KMAX )              !" Ð̎̌W 
      REAL       SBETZ ( KMAX )              !" Ð̎̌W 
      LOGICAL    OSET                        !" 萔ZbgtO
      DATA       OSET / .FALSE. /
      SAVE       SALPHZ , SBETZ, OSET
*   [INTERNAL WORK] 
      INTEGER    IJ, K, NM
      REAL       AKAPPA
*
      IF ( .NOT. OSET ) THEN
         CALL MSGDMP( 'E','WHYDRO','CONSTANTS ARE NOT SET.')
      ENDIF
*
*"         < 1. XyNgԂł̐ςݏグ >
*
      DO 1100 NM = 1, NMDIM
            WDPHI ( NM,1 ) = CP * SALPHZ( 1 ) * WDT ( NM,1 )
 1100 CONTINUE
*
      DO 1200 K = 2, KMAX
         DO 1200 NM = 1, NMDIM
            WDPHI ( NM,K ) = WDPHI( NM,K-1 )
     &                          + CP * SALPHZ( K   ) * WDT ( NM,K   )
     &                          + CP * SBETZ ( K-1 ) * WDT ( NM,K-1 )
 1200 CONTINUE
*
      RETURN
*======================================================================
      ENTRY      GHYDRO     !" Ð̎ ( iq_ )
     O         ( GDPHI ,
     I           GDT     )
*
      IF ( .NOT. OSET ) THEN
         CALL MSGDMP( 'E','GHYDRO','CONSTANTS ARE NOT SET.')
      ENDIF
*
*"         < 2. iqԂł̐ςݏグ >
*
      DO 2100 IJ = 1, IDIM*JDIM
            GDPHI ( IJ,1 ) = CP * SALPHZ( 1   ) * GDT ( IJ,1 )
 2100 CONTINUE
*
      DO 2200 K = 2, KMAX
         DO 2200 IJ = 1, IDIM*JDIM
            GDPHI ( IJ,K ) = GDPHI( IJ,K-1 )
     &                     + CP * SALPHZ( K   ) * GDT ( IJ,K   )
     &                     + CP * SBETZ ( K-1 ) * GDT ( IJ,K-1 )
 2200 CONTINUE
*
      RETURN
*======================================================================
      ENTRY      HYDROS         !" Ð̌W̐ݒ
     I         ( SIG   , SIGM  )
*
      AKAPPA = RAIR / CP
      DO 3100 K = 1, KMAX
         SALPHZ( K ) =        ( SIGM( K   )/SIG ( K ) )**AKAPPA - 1.  
         SBETZ ( K ) = 1.   - ( SIGM( K+1 )/SIG ( K ) )**AKAPPA
 3100 CONTINUE
*
      OSET = .TRUE.
*
      RETURN
*===================================================================
      ENTRY      HYDROQ       !" Ð̌W̎Q
     O         ( SALPHA, SBETA )
*
      CALL COPY ( SALPHA, SALPHZ, KMAX )
      CALL COPY ( SBETA , SBETZ , KMAX )
*
      RETURN
      END
