* 1 p2ccll.F
* PACKAGE P2CCLL    !" ʪ(2) ή
*
***********************************************************************
      SUBROUTINE CCLLEV     !" ή
     O         ( GDTC  , GDQC  , KBTM  , KTOP  ,
     I           GDT   , GDQ   , GDP   , GDZ   ,
     I           IREUSE,
     W           ADIAF                           )
*
*"       첼ü = LCL
*"       ȥ쥤
*
*   [PARAM] 
* 1 ..\include/zcdim.F
* PACKAGE  ZGT10L5 !"  ʻȿ
*
      INTEGER     IMAX           !" ٳʻҿ
      INTEGER     JMAX           !" ٳʻҿ
      INTEGER     IDIM           !" 󥵥
      INTEGER     JDIM           !" 󥵥
      INTEGER     MMAX           !" ȿ
      INTEGER     LMAX           !" ȿ
      INTEGER     NMAX           !" ȿ
      INTEGER     MINT           !" ȿֳ
      INTEGER     KMAX           !" ľؿ
      INTEGER     KDIM           !" ľ󥵥
      INTEGER     NMDIM          !" ʿȿʬ
      INTEGER     JMXHF          !" JMAX/2+1
      INTEGER     NWORK          !" ΰ礭
*
      PARAMETER ( IMAX  = 32,     JMAX = 16,
     &            IDIM  = IMAX+1, JDIM = JMAX,
     &            MMAX  = 10,     LMAX = 10,    NMAX = LMAX, MINT = 1,
     &            KMAX  =  5,     KDIM = KMAX,
     &            NMDIM = (MMAX/MINT+1)*(2*(NMAX+1)-MMAX)
     &                  - (NMAX-LMAX)/MINT*(NMAX-LMAX+1),
     &            JMXHF = JMAX/2+1,
     &            NWORK = IDIM*JDIM*KMAX*12                           )
* 1 ..\include/zccom.F
* 19 p2ccll.F
* PACKAGE ZHDIM  !" W萔(common)  
*
*"  [HIS]  90/08/31(numaguti)
*
      REAL       ER             !" na
      REAL       GRAV                        !" d͉x
      REAL       CP                          !" C舳M
      REAL       RAIR                        !" CC̒萔
      REAL       EL                          !" ̋Ì̐M
      REAL       CPVAP                       !" C舳M
      REAL       RVAP                        !" CC̒萔
      REAL       DH2O                        !" ̖x
      REAL       EPSV                        !" ƑC̕qʔ
      REAL       ES0                         !" OOaCFo
      REAL       STB                         !" Stefan-Boltzman
      REAL       FKARM                       !" Karman 萔
      REAL       EPSVT                       !" 1/-1
*
      COMMON   /COMCON/
     &          ER    , GRAV  ,
     &          CP    , RAIR  ,
     &          EL    , CPVAP , RVAP  , DH2O  , EPSV  , ES0   ,
     &          STB   , FKARM , EPSVT
* 20 p2ccll.F
*
*   [OUTPUT] 
      REAL       GDTC  ( IDIM*JDIM, KMAX )   !" β
      REAL       GDQC  ( IDIM*JDIM, KMAX )   !" 漾
      INTEGER    KBTM  ( IDIM*JDIM )         !" ٥
      INTEGER    KTOP  ( IDIM*JDIM )         !" ĺ٥
*
*   [INPUT] 
      REAL       GDT   ( IDIM*JDIM, KMAX )   !"   
      REAL       GDQ   ( IDIM*JDIM, KMAX )   !" 漾  
      REAL       GDP   ( IDIM*JDIM, KMAX )   !"   
      REAL       GDZ   ( IDIM*JDIM, KMAX )   !"    
*
      INTEGER    IREUSE                      !" ͺѥե饰
*
*   [WORK] 
      REAL       ADIAF ( IDIM*JDIM, KMAX )   !" Ǯ߲Ψ
*
*   [INTERNAL PARM] 
      INTEGER    KBMIN
      INTEGER    KBMAX
      DATA       KBMIN  / 1    /
      DATA       KBMAX  / KMAX /
      REAL       EPST                        !" ԰εƸ
      DATA       EPST  / 0.0   /
      REAL       ENTR                        !" ȥ쥤Ψ
      DATA       ENTR  / 0.0   /
      NAMELIST  /NMCCLL/  KBMIN, KBMAX, EPST, ENTR
*
      LOGICAL    OFIRST, OSET
      DATA       OFIRST, OSET  / .TRUE., .FALSE. /
      SAVE
*
*   [INTERNAL WORK] 
      INTEGER    KBTMZ ( IDIM*JDIM )         !" ٥
      INTEGER    KTOPZ ( IDIM*JDIM )         !" ĺ٥
*     
      INTEGER    IJ, K, KUNDEF
      INTEGER    IFPAR, JFPAR
      REAL       AKAPPA, ELF
      REAL       RENTR, QSAT, DQSAT, QEXE, DT, DQ
*
* 1 ..\include/zqsat.F
* PACKAGE ZQSAT     !" Clausis-Clapeyron ̎(֐)
*
*"    QSAT:  saturation water vapour mixing ratio
*"    DQSAT: d(QSAT)/d(T)
*
      REAL       FQSAT
      REAL       FDQSAT
      REAL       T, P, QS
*
      FQSAT ( T,P )    = EPSV * ES0
     &                   * EXP( EL/RVAP *( 1./273. - 1./T ) )
     &                   / P
      FDQSAT( T,QS )   = EL * QS / ( RVAP * T*T )
* 67 p2ccll.F
*
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' CONVECTIVE CLOUD LAYER P2.3 DATE=92/02/07'
         OFIRST = .FALSE.
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMCCLL, END=90 )
   90    WRITE  ( JFPAR, NMCCLL )
*
         KUNDEF = -1
      ENDIF
*
*"         < 0. IREUSE = 1: ͺ (shallow convection) >
*
      IF ( ( IREUSE .EQ. 1 ) .AND. OSET ) THEN
         DO 100 IJ = 1, IDIM*JDIM
            KBTM ( IJ ) = KBTMZ ( IJ )
            KTOP ( IJ ) = KTOPZ ( IJ )
  100    CONTINUE
         OSET = .FALSE.
      ENDIF
*
      IF ( IREUSE .NE. 1 ) OSET = .TRUE.
*
*
*"         < 1. ե׻ >
*
      AKAPPA = RAIR / CP
      DO 1100 K = 1, KMAX-1
         DO 1100 IJ = 1, IDIM*JDIM
            ADIAF( IJ,K ) = ( GDP( IJ,K+1 )/GDP( IJ,K ) ) **AKAPPA
 1100 CONTINUE
*
      ELF    = EL / CP
*
*"         < 2.  >
*
      DO 2100 IJ = 1, IDIM*JDIM
         KBTM  ( IJ ) = KUNDEF
         KTOP  ( IJ ) = KUNDEF
 2100 CONTINUE
*
      DO 2200 IJ = 1, IDIM*JDIM
         GDTC( IJ,1 ) = GDT( IJ,1 )
         GDQC( IJ,1 ) = GDQ( IJ,1 )
 2200 CONTINUE
*
*"         < 3. 졦ĺ >
*
      DO 3100 K = 2, KMAX
         DO 3110 IJ = 1, IDIM*JDIM
*
            IF ( KBTM( IJ ) .EQ. KUNDEF ) THEN
*
*"               < 3.1 夲ŷ >
*
               GDTC( IJ,K ) = GDTC( IJ,K-1 ) * ADIAF( IJ,K-1 )
               GDQC( IJ,K ) = GDQC( IJ,K-1 )
               QSAT         = FQSAT( GDTC( IJ,K ),GDP( IJ,K ) )
*
               IF (  ( GDQC( IJ,K ) .GE. QSAT ).AND.
     &               ( K .GE. KBMIN )          .AND.
     &               ( K .LE. KBMAX )                ) THEN
                  KBTM( IJ )   = K
                  GDTC( IJ,K ) = GDT( IJ,K )
                  GDQC( IJ,K ) = FQSAT( GDTC( IJ,K ), GDP( IJ,K ) )
               ENDIF
*
            ELSE IF ( KTOP( IJ ) .EQ. KUNDEF )  THEN
*
*"               < 3.2 徺 >
*
               RENTR        = ENTR * ( GDZ( IJ,K ) - GDZ( IJ,K-1 ) )
               RENTR        = MIN( RENTR, 1. )
*
               GDTC( IJ,K ) = ( 1.-RENTR ) 
     &                         * GDTC( IJ,K-1 ) * ADIAF( IJ,K-1 )
     &                       + RENTR 
     &                         * ( GDT( IJ,K-1 ) + GDT( IJ,K ) )/2.  
               GDQC( IJ,K ) = ( 1.  -RENTR ) * GDQC( IJ,K-1 )
     &                       + RENTR 
     &                         * ( GDQ( IJ,K-1 ) + GDQ( IJ,K ) )/2.  
*
               QSAT         = FQSAT( GDTC( IJ,K ),GDP( IJ,K ) )
*
               IF ( GDQC( IJ,K ) .GT. QSAT ) THEN
                  DQSAT        = FDQSAT( GDTC( IJ,K ), QSAT  )
                  QEXE         = GDQC ( IJ,K ) - QSAT
                  DT           = ELF * QEXE / ( 1. + ELF * DQSAT )
                  DQ           = DQSAT * DT
*
                  GDTC( IJ,K ) = GDTC( IJ,K ) + DT
                  GDQC( IJ,K ) = QSAT         + DQ
               ENDIF
*
*"               < 3.3 ٥å >
*
               IF ( GDTC( IJ,K ) .LT. GDT( IJ,K )-EPST ) THEN
*
                  IF ( K .EQ. KBTM( IJ )+1  ) THEN
                     KBTM( IJ   ) = K
                     GDTC( IJ,K ) = GDT( IJ,K )
                     GDQC( IJ,K ) = FQSAT( GDTC( IJ,K ), GDP( IJ,K ) )
                  ELSE
                     KTOP( IJ ) = K - 1
                  ENDIF
*
               ELSE IF ( K .EQ. KMAX ) THEN
                  KTOP( IJ ) = K
               ENDIF
*
            ENDIF
*
 3110    CONTINUE
 3100 CONTINUE
*
      DO 3300 IJ = 1, IDIM*JDIM
         IF ( KTOP( IJ ) .EQ. KUNDEF ) THEN
            KBTM( IJ ) = KUNDEF
         ENDIF
*
         KBTMZ ( IJ ) = KBTM ( IJ )
         KTOPZ ( IJ ) = KTOP ( IJ )
 3300 CONTINUE
*
      RETURN
      END
