* PACKAGE P2RADL  !" ʪ(2) Ĺ(¿)
*
*"  93/08/29 ݺ            Ĺѹ
***********************************************************************
      SUBROUTINE LNGFLX           !" Ĺͥեå
     O         ( RFLUX , DRFLUX,
     I           GDT   , GDTG  , TAUQ  , TAUA  ,
     W           TRNSM1, TRNSM2, TRANS , PIB   , PIBGND  )
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                       !" ʻȿ
      INCLUDE   (ZCCOM)                       !" ɸʪ
#else
#include        "zcdim.F"                     !" ʻȿ
#include        "zccom.F"                     !" ɸʪ
#endif
*
*   [OUTPUT] 
      REAL       RFLUX  ( IDIM*JDIM, KMAX+1 )     !" Ĺȥեå
      REAL       DRFLUX ( IDIM*JDIM, KMAX+1, 0:1 )!" ĹɽѲ
*
*   [INPUT] 
      REAL       GDT    ( IDIM*JDIM, KMAX   ) !" ()
      REAL       GDTG   ( IDIM*JDIM )         !" ɽ̲
      REAL       TAUQ   ( IDIM*JDIM, KMAX+1 ) !" Ū
      REAL       TAUA   ( IDIM*JDIM, KMAX+1 ) !" Ū絤
*
*   [WORK] 
      REAL       TRNSM1 ( IDIM*JDIM, KMAX+1 ) !" 1/2 ٥뤫Ʃ᷸
      REAL       TRNSM2 ( IDIM*JDIM, KMAX+1 ) !" 3/2 ٥뤫Ʃ᷸
*                                                !" ݺ 93/08/29 ɲ
      REAL       TRANS  ( IDIM*JDIM, KMAX+1 ) !" Ʃ᷸
      REAL       PIB    ( IDIM*JDIM, KMAX+1 ) !" У¡ң**4
      REAL       PIBGND ( IDIM*JDIM )         !" ɽΦУ
*
*   [INTERNAL PARM] 
      INTEGER    NCLNGD
      PARAMETER (NCLNGD = 10)
      INTEGER    NCLNG                        !" ĹȥХɿ
      REAL       ABSQL  ( NCLNGD )            !" εۼ
      REAL       ABSAL  ( NCLNGD )            !" εۼ
      REAL       RWGTL  ( NCLNGD )            !" Хɥ
      REAL       PATHC                        !" ϩĹΥե
      DATA       NCLNG  / 4 /
      DATA       ABSQL  / 8.0  , 1.0  , 0.1  , 0.0  , 6*0.   /
      DATA       ABSAL  / 0.0  , 0.0  , 0.0  , 5.E-5, 6*0.   /
      DATA       RWGTL  / 0.2  , 0.1  , 0.1  , 0.6  , 6*0.   /
      DATA       PATHC  / 1.5   /
*
      NAMELIST  /NMRADL/ NCLNG , ABSQL , ABSAL , RWGTL , PATHC
      SAVE
*
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
*
*   [INTERNAL WORK] 
      INTEGER    IJ, K, KK, IC
      INTEGER    IFPAR, JFPAR
      REAL       SUMWGL
*
*   [ONCE] 
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' LONGWAVE RADIATION N-BAND DATE=93/08/29'
         OFIRST = .FALSE.
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMRADL, END=190 )
  190    WRITE  ( JFPAR, NMRADL )
*
         SUMWGL = 0.  
         DO 210 IC = 1, NCLNG
            SUMWGL = SUMWGL + RWGTL( IC )
  210    CONTINUE
         DO 220 IC = 1, NCLNG
            RWGTL( IC ) =  RWGTL( IC ) / SUMWGL
  220    CONTINUE
*
      ENDIF
*
*"         < 1. У¤η׻ >
*
      DO 1100 K = 1, KMAX
         DO 1110 IJ = 1, IDIM*JDIM
            PIB  ( IJ,K ) = STB * ( GDT( IJ,K )**4 )
 1110    CONTINUE
 1100 CONTINUE
*
      DO 1200 IJ = 1, IDIM*JDIM
         PIBGND( IJ ) = STB * ( GDTG( IJ )**4 )
 1200 CONTINUE
*
*"         < 2. Ʃؿ׻ >
*
      DO 2000 K = 1, KMAX+1
*
         CALL RESET ( TRANS, IDIM*JDIM*(KMAX+1) )
*
         DO 2100 IC = 1, NCLNG
            DO 2110 KK = 1, KMAX+1
               DO 2120 IJ = 1, IDIM*JDIM
                  TRANS( IJ,KK )
     &            = TRANS( IJ,KK )
     &              +  RWGTL ( IC )
     &                  * EXP( - PATHC
     &                         * (  ABSQL(IC)*ABS(  TAUQ( IJ,KK )
     &                                            - TAUQ( IJ,K  )  )
     &                            + ABSAL(IC)*ABS(  TAUA( IJ,KK )
     &                                            - TAUA( IJ,K  )  )  )
     &                       )
 2120          CONTINUE
 2110       CONTINUE
 2100    CONTINUE
*
*"      < 3.   ͥեå׻  >       !"  ݺ 93/08/29 ѹ
*
         DO 3100 IJ = 1, IDIM*JDIM
            RFLUX ( IJ,K ) = PIBGND ( IJ ) * TRANS ( IJ, 1 )
 3100    CONTINUE

         DO 3200 KK = 1, KMAX
            DO 3200 IJ = 1, IDIM*JDIM
                RFLUX( IJ,K ) 
     &             = RFLUX ( IJ, K ) 
     &               - PIB ( IJ, KK ) 
     &                 * ( TRANS ( IJ, KK ) - TRANS ( IJ , KK+1 ) ) 
 3200   CONTINUE
*
*"       < 4.  ׻Ʃؿ >       !"  ݺ 93/08/29 ѹ
*
        DO 4000 IJ= 1 ,IDIM*JDIM
            TRNSM1 ( IJ,K ) = TRANS( IJ,1 )
            TRNSM2 ( IJ,K ) = TRANS( IJ,2 )
 4000   CONTINUE
*
 2000 CONTINUE
*
*"         < 5. ɽ >               !"  ݺ 93/08/29 ѹ
*
      DO 5100 K = 1, KMAX+1
         DO 5110 IJ = 1, IDIM*JDIM
            DRFLUX( IJ,K,0 ) = 4. * PIBGND( IJ   ) / GDTG  ( IJ )
     &                            * TRNSM1( IJ,K )
            DRFLUX( IJ,K,1 ) = 4. * PIB   ( IJ,1 ) / GDT  ( IJ,1 )
     &                         * ( TRNSM2 ( IJ,K ) - TRNSM1 ( IJ,K ) )      
 5110    CONTINUE
 5100 CONTINUE
*
      RETURN
      END
