* 1 p2radl.F
* PACKAGE P2RADL  !" ʪ(2) Ĺ(¿)
*
*"  93/08/29 ݺ            Ĺѹ
***********************************************************************
      SUBROUTINE LNGFLX           !" Ĺͥեå
     O         ( RFLUX , DRFLUX,
     I           GDT   , GDTG  , TAUQ  , TAUA  ,
     W           TRNSM1, TRNSM2, TRANS , PIB   , PIBGND  )
*
*   [PARAM] 
* 1 ..\include/zcdim.F
* PACKAGE  ZGT10L5 !"  ʻȿ
*
      INTEGER     IMAX           !" ٳʻҿ
      INTEGER     JMAX           !" ٳʻҿ
      INTEGER     IDIM           !" 󥵥
      INTEGER     JDIM           !" 󥵥
      INTEGER     MMAX           !" ȿ
      INTEGER     LMAX           !" ȿ
      INTEGER     NMAX           !" ȿ
      INTEGER     MINT           !" ȿֳ
      INTEGER     KMAX           !" ľؿ
      INTEGER     KDIM           !" ľ󥵥
      INTEGER     NMDIM          !" ʿȿʬ
      INTEGER     JMXHF          !" JMAX/2+1
      INTEGER     NWORK          !" ΰ礭
*
      PARAMETER ( IMAX  = 32,     JMAX = 16,
     &            IDIM  = IMAX+1, JDIM = JMAX,
     &            MMAX  = 10,     LMAX = 10,    NMAX = LMAX, MINT = 1,
     &            KMAX  =  5,     KDIM = KMAX,
     &            NMDIM = (MMAX/MINT+1)*(2*(NMAX+1)-MMAX)
     &                  - (NMAX-LMAX)/MINT*(NMAX-LMAX+1),
     &            JMXHF = JMAX/2+1,
     &            NWORK = IDIM*JDIM*KMAX*12                           )
* 1 ..\include/zccom.F
* 16 p2radl.F
* PACKAGE ZHDIM  !" W萔(common)  
*
*"  [HIS]  90/08/31(numaguti)
*
      REAL       ER             !" na
      REAL       GRAV                        !" d͉x
      REAL       CP                          !" C舳M
      REAL       RAIR                        !" CC̒萔
      REAL       EL                          !" ̋Ì̐M
      REAL       CPVAP                       !" C舳M
      REAL       RVAP                        !" CC̒萔
      REAL       DH2O                        !" ̖x
      REAL       EPSV                        !" ƑC̕qʔ
      REAL       ES0                         !" OOaCFo
      REAL       STB                         !" Stefan-Boltzman
      REAL       FKARM                       !" Karman 萔
      REAL       EPSVT                       !" 1/-1
*
      COMMON   /COMCON/
     &          ER    , GRAV  ,
     &          CP    , RAIR  ,
     &          EL    , CPVAP , RVAP  , DH2O  , EPSV  , ES0   ,
     &          STB   , FKARM , EPSVT
* 17 p2radl.F
*
*   [OUTPUT] 
      REAL       RFLUX  ( IDIM*JDIM, KMAX+1 )     !" Ĺȥեå
      REAL       DRFLUX ( IDIM*JDIM, KMAX+1, 0:1 )!" ĹɽѲ
*
*   [INPUT] 
      REAL       GDT    ( IDIM*JDIM, KMAX   ) !" ()
      REAL       GDTG   ( IDIM*JDIM )         !" ɽ̲
      REAL       TAUQ   ( IDIM*JDIM, KMAX+1 ) !" Ū
      REAL       TAUA   ( IDIM*JDIM, KMAX+1 ) !" Ū絤
*
*   [WORK] 
      REAL       TRNSM1 ( IDIM*JDIM, KMAX+1 ) !" 1/2 ٥뤫Ʃ᷸
      REAL       TRNSM2 ( IDIM*JDIM, KMAX+1 ) !" 3/2 ٥뤫Ʃ᷸
*                                                !" ݺ 93/08/29 ɲ
      REAL       TRANS  ( IDIM*JDIM, KMAX+1 ) !" Ʃ᷸
      REAL       PIB    ( IDIM*JDIM, KMAX+1 ) !" У¡ң**4
      REAL       PIBGND ( IDIM*JDIM )         !" ɽΦУ
*
*   [INTERNAL PARM] 
      INTEGER    NCLNGD
      PARAMETER (NCLNGD = 10)
      INTEGER    NCLNG                        !" ĹȥХɿ
      REAL       ABSQL  ( NCLNGD )            !" εۼ
      REAL       ABSAL  ( NCLNGD )            !" εۼ
      REAL       RWGTL  ( NCLNGD )            !" Хɥ
      REAL       PATHC                        !" ϩĹΥե
      DATA       NCLNG  / 4 /
      DATA       ABSQL  / 8.0  , 1.0  , 0.1  , 0.0  , 6*0.   /
      DATA       ABSAL  / 0.0  , 0.0  , 0.0  , 5.E-5, 6*0.   /
      DATA       RWGTL  / 0.2  , 0.1  , 0.1  , 0.6  , 6*0.   /
      DATA       PATHC  / 1.5   /
*
      NAMELIST  /NMRADL/ NCLNG , ABSQL , ABSAL , RWGTL , PATHC
      SAVE
*
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
*
*   [INTERNAL WORK] 
      INTEGER    IJ, K, KK, IC
      INTEGER    IFPAR, JFPAR
      REAL       SUMWGL
*
*   [ONCE] 
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' LONGWAVE RADIATION N-BAND DATE=93/08/29'
         OFIRST = .FALSE.
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMRADL, END=190 )
  190    WRITE  ( JFPAR, NMRADL )
*
         SUMWGL = 0.  
         DO 210 IC = 1, NCLNG
            SUMWGL = SUMWGL + RWGTL( IC )
  210    CONTINUE
         DO 220 IC = 1, NCLNG
            RWGTL( IC ) =  RWGTL( IC ) / SUMWGL
  220    CONTINUE
*
      ENDIF
*
*"         < 1. У¤η׻ >
*
      DO 1100 K = 1, KMAX
         DO 1110 IJ = 1, IDIM*JDIM
            PIB  ( IJ,K ) = STB * ( GDT( IJ,K )**4 )
 1110    CONTINUE
 1100 CONTINUE
*
      DO 1200 IJ = 1, IDIM*JDIM
         PIBGND( IJ ) = STB * ( GDTG( IJ )**4 )
 1200 CONTINUE
*
*"         < 2. Ʃؿ׻ >
*
      DO 2000 K = 1, KMAX+1
*
         CALL RESET ( TRANS, IDIM*JDIM*(KMAX+1) )
*
         DO 2100 IC = 1, NCLNG
            DO 2110 KK = 1, KMAX+1
               DO 2120 IJ = 1, IDIM*JDIM
                  TRANS( IJ,KK )
     &            = TRANS( IJ,KK )
     &              +  RWGTL ( IC )
     &                  * EXP( - PATHC
     &                         * (  ABSQL(IC)*ABS(  TAUQ( IJ,KK )
     &                                            - TAUQ( IJ,K  )  )
     &                            + ABSAL(IC)*ABS(  TAUA( IJ,KK )
     &                                            - TAUA( IJ,K  )  )  )
     &                       )
 2120          CONTINUE
 2110       CONTINUE
 2100    CONTINUE
*
*"      < 3.   ͥեå׻  >       !"  ݺ 93/08/29 ѹ
*
         DO 3100 IJ = 1, IDIM*JDIM
            RFLUX ( IJ,K ) = PIBGND ( IJ ) * TRANS ( IJ, 1 )
 3100    CONTINUE

         DO 3200 KK = 1, KMAX
            DO 3200 IJ = 1, IDIM*JDIM
                RFLUX( IJ,K ) 
     &             = RFLUX ( IJ, K ) 
     &               - PIB ( IJ, KK ) 
     &                 * ( TRANS ( IJ, KK ) - TRANS ( IJ , KK+1 ) ) 
 3200   CONTINUE
*
*"       < 4.  ׻Ʃؿ >       !"  ݺ 93/08/29 ѹ
*
        DO 4000 IJ= 1 ,IDIM*JDIM
            TRNSM1 ( IJ,K ) = TRANS( IJ,1 )
            TRNSM2 ( IJ,K ) = TRANS( IJ,2 )
 4000   CONTINUE
*
 2000 CONTINUE
*
*"         < 5. ɽ >               !"  ݺ 93/08/29 ѹ
*
      DO 5100 K = 1, KMAX+1
         DO 5110 IJ = 1, IDIM*JDIM
            DRFLUX( IJ,K,0 ) = 4. * PIBGND( IJ   ) / GDTG  ( IJ )
     &                            * TRNSM1( IJ,K )
            DRFLUX( IJ,K,1 ) = 4. * PIB   ( IJ,1 ) / GDT  ( IJ,1 )
     &                         * ( TRNSM2 ( IJ,K ) - TRNSM1 ( IJ,K ) )      
 5110    CONTINUE
 5100 CONTINUE
*
      RETURN
      END
