* 1 p2radm.F
* PACKAGE P2RADM   !" ʪ(2) (¿)*
*
*"  93/08/29 ݺ            Ĺѹ
*********************************************************************
      SUBROUTINE RADFLX            !" ͥեå
     O         ( RFLUX , RMTXS , DRFLUX,
     O           SFLUX ,
     I           GDT   , GDTG  , GDQ   , GDPM  ,
     I           IT    , IDATE , 
     C           ALON  , ALAT  , GRALB          )
*
*"       絤
*
*   [PARAM] 
* 1 ..\include/zcdim.F
* PACKAGE  ZGT10L5 !"  ʻȿ
*
      INTEGER     IMAX           !" ٳʻҿ
      INTEGER     JMAX           !" ٳʻҿ
      INTEGER     IDIM           !" 󥵥
      INTEGER     JDIM           !" 󥵥
      INTEGER     MMAX           !" ȿ
      INTEGER     LMAX           !" ȿ
      INTEGER     NMAX           !" ȿ
      INTEGER     MINT           !" ȿֳ
      INTEGER     KMAX           !" ľؿ
      INTEGER     KDIM           !" ľ󥵥
      INTEGER     NMDIM          !" ʿȿʬ
      INTEGER     JMXHF          !" JMAX/2+1
      INTEGER     NWORK          !" ΰ礭
*
      PARAMETER ( IMAX  = 32,     JMAX = 16,
     &            IDIM  = IMAX+1, JDIM = JMAX,
     &            MMAX  = 10,     LMAX = 10,    NMAX = LMAX, MINT = 1,
     &            KMAX  =  5,     KDIM = KMAX,
     &            NMDIM = (MMAX/MINT+1)*(2*(NMAX+1)-MMAX)
     &                  - (NMAX-LMAX)/MINT*(NMAX-LMAX+1),
     &            JMXHF = JMAX/2+1,
     &            NWORK = IDIM*JDIM*KMAX*12                           )
* 1 ..\include/zccom.F
* 20 p2radm.F
* PACKAGE ZHDIM  !" W萔(common)  
*
*"  [HIS]  90/08/31(numaguti)
*
      REAL       ER             !" na
      REAL       GRAV                        !" d͉x
      REAL       CP                          !" C舳M
      REAL       RAIR                        !" CC̒萔
      REAL       EL                          !" ̋Ì̐M
      REAL       CPVAP                       !" C舳M
      REAL       RVAP                        !" CC̒萔
      REAL       DH2O                        !" ̖x
      REAL       EPSV                        !" ƑC̕qʔ
      REAL       ES0                         !" OOaCFo
      REAL       STB                         !" Stefan-Boltzman
      REAL       FKARM                       !" Karman 萔
      REAL       EPSVT                       !" 1/-1
*
      COMMON   /COMCON/
     &          ER    , GRAV  ,
     &          CP    , RAIR  ,
     &          EL    , CPVAP , RVAP  , DH2O  , EPSV  , ES0   ,
     &          STB   , FKARM , EPSVT
* 21 p2radm.F
*
*   [OUTPUT] 
      REAL       RFLUX  ( IDIM*JDIM, KMAX+1 )     !" Ĺȥեå
      REAL       RMTXS  ( IDIM*JDIM,  -1:1 )      !" Աɽ
      REAL       DRFLUX ( IDIM*JDIM, KMAX+1, 0:1 )!" ĹɽѲ
      REAL       SFLUX  ( IDIM*JDIM, KMAX+1 )     !" ͥեå
*
*   [INPUT] 
      REAL       GDT    ( IDIM*JDIM, KMAX   ) !" ()  
*                                                !" ݺ 93/08/29 GDTM  
      REAL       GDTG   ( IDIM*JDIM )         !" ɽ̲
      REAL       GDQ    ( IDIM*JDIM, KMAX )   !" 漾  
      REAL       GDPM   ( IDIM*JDIM, KMAX+1 ) !" (Ⱦ)
      INTEGER    IT                           !" 
      INTEGER    IDATE  ( 6 )                 !" 
*
      REAL       ALON   ( IDIM )              !" 
      REAL       ALAT   ( JDIM )              !" 
      REAL       GRALB  ( IDIM*JDIM )         !" ɽ٥
*
*   [INTERNAL PARM]
      CHARACTER  TUNIT *4                     !" INTLNGñ
      INTEGER    INTLNG                       !" Ĺȷ׻ֳ
      INTEGER    INTSHT                       !" ûȷ׻ֳ
      DATA       TUNIT  / 'HOUR'/
      DATA       INTLNG / 3     /
      DATA       INTSHT / 1     /
*
      NAMELIST  /NMRADM/ TUNIT , INTLNG, INTSHT
*
*   [INTERNAL SAVE] 
      REAL       GDTZ  ( IDIM*JDIM    )       !" ΥƥåפǤβ 
*                                                !" ݺ 93/08/29 ɲ
*
      INTEGER    IORADL                       !" Ĺȷ׻ֳ֡
      INTEGER    IORADS                       !" ûȷ׻ֳ֡
      INTEGER    ITLSTL                       !" Ĺȷ׻
      INTEGER    ITLSTS                       !" ûȷ׻
*
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE
*
*   [INTERNAL WORK] 
      COMMON    /COMWRK/
     &           TAUQ  , TAUA   , TRNSM1, TRNSM2, TRANS ,
     &           PIB   , PIBGND , SECZET
      REAL       TAUQ   ( IDIM*JDIM, KMAX+1 ) !" Ū
      REAL       TAUA   ( IDIM*JDIM, KMAX+1 ) !" Ū
      REAL       TRNSM1 ( IDIM*JDIM, KMAX+1 ) !" 1/2 ٥뤫Ʃ᷸
      REAL       TRNSM2 ( IDIM*JDIM, KMAX+1 ) !" 3/2 ٥뤫Ʃ᷸
*                                                 !" ݺ 93/08/29 ɲ
      REAL       TRANS  ( IDIM*JDIM, KMAX+1 ) !" Ʃ᷸
      REAL       PIB    ( IDIM*JDIM, KMAX+1 ) !" У¡ң**4
      REAL       PIBGND ( IDIM*JDIM )         !" ɽΦУ
      REAL       SECZET ( IDIM*JDIM )         !" sec(ͳ)
*
      INTEGER    IJ, K
      INTEGER    IFPAR, JFPAR
*
*   [ONCE]
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' RADIATION PACKAGE - DATE=93/08/29 pochaka '
         OFIRST = .FALSE.
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMRADM, END=190 )
  190    WRITE  ( JFPAR, NMRADM )
*
         CALL ACTIME
     I      ( INTLNG, TUNIT  , '#'    ,
     O        IORADL                    )
         CALL ACTIME
     I      ( INTSHT, TUNIT  , '#'    ,
     O        IORADS                   )
         ITLSTL = IT - IORADL
         ITLSTS = IT - IORADS
      ENDIF
*
*"         < 1.  η׻ >
*
      CALL RESET ( TAUQ ( 1,KMAX+1 ), IDIM*JDIM )
      CALL RESET ( TAUA ( 1,KMAX+1 ), IDIM*JDIM )
      DO 1110  K = KMAX, 1, -1
         DO 1120 IJ = 1, IDIM*JDIM
            TAUQ ( IJ,K ) = TAUQ ( IJ,K+1 )
     &                       + GDQ( IJ,K )
     &                         * ( GDPM( IJ,K )-GDPM( IJ,K+1 ) )/ GRAV
            TAUA ( IJ,K ) = TAUA ( IJ,K+1 )
     &                       +   ( GDPM( IJ,K )-GDPM( IJ,K+1 ) )/ GRAV
 1120       CONTINUE
 1110    CONTINUE
 1100 CONTINUE
*
*
      IF (  ( IT - ITLSTL ) .GE. IORADL ) THEN
*
         ITLSTL = IT
*
*"         < 2. Ĺȥեåλ >     !"  ݺ 93/08/29 ѹ
*
         CALL LNGFLX
     O         ( RFLUX , DRFLUX,
     I           GDT   , GDTG  , TAUQ  , TAUA  ,
     W           TRNSM1, TRNSM2, TRANS , PIB   , PIBGND  )
*
      ELSE 
*
         DO 2000 K = 1, KMAX+1             
            DO 2000 IJ = 1, IDIM*JDIM
               RFLUX ( IJ,K ) = RFLUX ( IJ,K ) 
     &                        + DRFLUX ( IJ,K,1 ) 
     &                           * ( GDT ( IJ,1 ) - GDTZ ( IJ ) )
               DRFLUX ( IJ,K,1 ) = DRFLUX ( IJ,K,1 ) 
     &                             / GDTZ ( IJ   )**3
     &                             * GDT  ( IJ,1 )**3
 2000    CONTINUE

      ENDIF
*
      DO 2100 IJ = 1, IDIM*JDIM
         GDTZ ( IJ ) = GDT ( IJ , 1 )
 2100 CONTINUE
*
*"         < 3. Ĺȱѹ >             !" ݺ 93/08/29 ѹ
*
      DO 3100 IJ = 1, IDIM*JDIM
         RMTXS ( IJ,0  ) =   DRFLUX( IJ,1,0 )
         RMTXS ( IJ,1  ) =   DRFLUX( IJ,1,1 )
         RMTXS ( IJ,-1 ) = 0.  
 3100 CONTINUE
*
*
      IF (  ( IT - ITLSTS ) .GE. IORADS ) THEN
*
         ITLSTS = IT
*
*"         < 4. û >
*
         CALL SHTINS
     O         ( SFLUX(1,KMAX+1), SECZET ,
     I           IDATE ,
     C           ALON  , ALAT             )
*
*"         < 5. ûȥեå >
*
         CALL SHTFLX
     M         ( SFLUX ,
     I           TAUQ  , TAUA  , SECZET,
     C           GRALB                  )
*
      ENDIF
*
      RETURN
      END
************************************************************************
      SUBROUTINE RADCOR                      !" ͥեå
     O         ( RFLUXC ,
     I           RFLUX  , DRFLUX, GTT   , GTTG  , DELT  )
*
*   [PARAM] 
* 1 ..\include/zcdim.F
* PACKAGE  ZGT10L5 !"  ʻȿ
*
      INTEGER     IMAX           !" ٳʻҿ
      INTEGER     JMAX           !" ٳʻҿ
      INTEGER     IDIM           !" 󥵥
      INTEGER     JDIM           !" 󥵥
      INTEGER     MMAX           !" ȿ
      INTEGER     LMAX           !" ȿ
      INTEGER     NMAX           !" ȿ
      INTEGER     MINT           !" ȿֳ
      INTEGER     KMAX           !" ľؿ
      INTEGER     KDIM           !" ľ󥵥
      INTEGER     NMDIM          !" ʿȿʬ
      INTEGER     JMXHF          !" JMAX/2+1
      INTEGER     NWORK          !" ΰ礭
*
      PARAMETER ( IMAX  = 32,     JMAX = 16,
     &            IDIM  = IMAX+1, JDIM = JMAX,
     &            MMAX  = 10,     LMAX = 10,    NMAX = LMAX, MINT = 1,
     &            KMAX  =  5,     KDIM = KMAX,
     &            NMDIM = (MMAX/MINT+1)*(2*(NMAX+1)-MMAX)
     &                  - (NMAX-LMAX)/MINT*(NMAX-LMAX+1),
     &            JMXHF = JMAX/2+1,
     &            NWORK = IDIM*JDIM*KMAX*12                           )
* 187 p2radm.F
*
*   [OUTPUT] 
      REAL       RFLUXC ( IDIM*JDIM, KMAX+1 )    !" Ĺȥեå 
*
*   [INPUT] 
      REAL       RFLUX  ( IDIM*JDIM, KMAX+1 )    !" Ĺȥեå
      REAL       DRFLUX ( IDIM*JDIM, KMAX+1, 0:1 )!" ĹɽѲ
      REAL       GTT    ( IDIM*JDIM, KMAX )       !" ٻѲ
      REAL       GTTG   ( IDIM*JDIM )             !" ɽѲΨ
      REAL       DELT                             !" ֹߦt
*
*   [INTERNAL WORK] 
      INTEGER    IJ, K
*
*"  <  ͥեå >                    !" 93/08/29 ѹ
*
      DO 1100 K = 1, KMAX+1
         DO 1100 IJ = 1, IDIM*JDIM
            RFLUXC ( IJ,K ) = RFLUX ( IJ,K )
     &                      + (  GTTG ( IJ )   * DRFLUX ( IJ,K,0 ) 
     &                         + GTT  ( IJ,1 ) * DRFLUX ( IJ,K,1 ) )
     &                        * DELT 
 1100 CONTINUE
*
      RETURN
      END
*********************************************************************
      SUBROUTINE RADTND               !" ͲǮΨ
     O         ( GTTRL , GTTRS ,
     I           RFLUX , SFLUX , GDPM    )
*
*   [PARAM] 
* 1 ..\include/zcdim.F
* PACKAGE  ZGT10L5 !"  ʻȿ
*
      INTEGER     IMAX           !" ٳʻҿ
      INTEGER     JMAX           !" ٳʻҿ
      INTEGER     IDIM           !" 󥵥
      INTEGER     JDIM           !" 󥵥
      INTEGER     MMAX           !" ȿ
      INTEGER     LMAX           !" ȿ
      INTEGER     NMAX           !" ȿ
      INTEGER     MINT           !" ȿֳ
      INTEGER     KMAX           !" ľؿ
      INTEGER     KDIM           !" ľ󥵥
      INTEGER     NMDIM          !" ʿȿʬ
      INTEGER     JMXHF          !" JMAX/2+1
      INTEGER     NWORK          !" ΰ礭
*
      PARAMETER ( IMAX  = 32,     JMAX = 16,
     &            IDIM  = IMAX+1, JDIM = JMAX,
     &            MMAX  = 10,     LMAX = 10,    NMAX = LMAX, MINT = 1,
     &            KMAX  =  5,     KDIM = KMAX,
     &            NMDIM = (MMAX/MINT+1)*(2*(NMAX+1)-MMAX)
     &                  - (NMAX-LMAX)/MINT*(NMAX-LMAX+1),
     &            JMXHF = JMAX/2+1,
     &            NWORK = IDIM*JDIM*KMAX*12                           )
* 1 ..\include/zccom.F
* 225 p2radm.F
* PACKAGE ZHDIM  !" W萔(common)  
*
*"  [HIS]  90/08/31(numaguti)
*
      REAL       ER             !" na
      REAL       GRAV                        !" d͉x
      REAL       CP                          !" C舳M
      REAL       RAIR                        !" CC̒萔
      REAL       EL                          !" ̋Ì̐M
      REAL       CPVAP                       !" C舳M
      REAL       RVAP                        !" CC̒萔
      REAL       DH2O                        !" ̖x
      REAL       EPSV                        !" ƑC̕qʔ
      REAL       ES0                         !" OOaCFo
      REAL       STB                         !" Stefan-Boltzman
      REAL       FKARM                       !" Karman 萔
      REAL       EPSVT                       !" 1/-1
*
      COMMON   /COMCON/
     &          ER    , GRAV  ,
     &          CP    , RAIR  ,
     &          EL    , CPVAP , RVAP  , DH2O  , EPSV  , ES0   ,
     &          STB   , FKARM , EPSVT
* 226 p2radm.F
*
*   [OUTPUT] 
      REAL       GTTRL  ( IDIM*JDIM, KMAX   ) !" ĹȲǮΨ
      REAL       GTTRS  ( IDIM*JDIM, KMAX   ) !" ûȲǮΨ
*
*   [INPUT] 
      REAL       RFLUX  ( IDIM*JDIM, KMAX+1 ) !" Ĺȥեå
      REAL       SFLUX  ( IDIM*JDIM, KMAX+1 ) !" ûȥեå
      REAL       GDPM   ( IDIM*JDIM, KMAX+1 ) !" 
*
*   [INTERNAL WORK] 
      INTEGER    IJ, K
*
*
      DO 1100 K = 1, KMAX
         DO 1110 IJ = 1, IDIM*JDIM
            GTTRL ( IJ,K )
     &         =  (  RFLUX( IJ,K ) - RFLUX( IJ,K+1 )   )
     &           /(  GDPM ( IJ,K ) - GDPM ( IJ,K+1 )   )
     &           / CP * GRAV
 1110    CONTINUE
 1100 CONTINUE
*
      DO 2100 K = 1, KMAX
         DO 2110 IJ = 1, IDIM*JDIM
            GTTRS ( IJ,K )
     &         =  (  SFLUX( IJ,K ) - SFLUX( IJ,K+1 )  )
     &           /(  GDPM ( IJ,K ) - GDPM ( IJ,K+1 )   )
     &           / CP * GRAV
 2110    CONTINUE
 2100 CONTINUE
*
      RETURN
      END
