* 1 p2sfcm.F
* PACKAGE P2SFCM  !" ʪ(2) ɽեå
*
***********************************************************************
      SUBROUTINE SFCUVT           !"  ɽեå
     M         ( UFLUX , VFLUX , TFLUX , QFLUX ,
     O           UMTXS , TMTXS , QMTXS ,
     I           GDU   , GDV   , GDT   , GDTM  , GDTG  , GDQ   ,
     I           GDP   , GDPM  , GDZ   ,
     I           GRBET , GRZ0  , IDSFC                          )
*
*   [PARAM] 
* 1 ..\include/zcdim.F
* PACKAGE  ZGT10L5 !"  ʻȿ
*
      INTEGER     IMAX           !" ٳʻҿ
      INTEGER     JMAX           !" ٳʻҿ
      INTEGER     IDIM           !" 󥵥
      INTEGER     JDIM           !" 󥵥
      INTEGER     MMAX           !" ȿ
      INTEGER     LMAX           !" ȿ
      INTEGER     NMAX           !" ȿ
      INTEGER     MINT           !" ȿֳ
      INTEGER     KMAX           !" ľؿ
      INTEGER     KDIM           !" ľ󥵥
      INTEGER     NMDIM          !" ʿȿʬ
      INTEGER     JMXHF          !" JMAX/2+1
      INTEGER     NWORK          !" ΰ礭
*
      PARAMETER ( IMAX  = 32,     JMAX = 16,
     &            IDIM  = IMAX+1, JDIM = JMAX,
     &            MMAX  = 10,     LMAX = 10,    NMAX = LMAX, MINT = 1,
     &            KMAX  =  5,     KDIM = KMAX,
     &            NMDIM = (MMAX/MINT+1)*(2*(NMAX+1)-MMAX)
     &                  - (NMAX-LMAX)/MINT*(NMAX-LMAX+1),
     &            JMXHF = JMAX/2+1,
     &            NWORK = IDIM*JDIM*KMAX*12                           )
* 1 ..\include/zccom.F
* 17 p2sfcm.F
* PACKAGE ZHDIM  !" W萔(common)  
*
*"  [HIS]  90/08/31(numaguti)
*
      REAL       ER             !" na
      REAL       GRAV                        !" d͉x
      REAL       CP                          !" C舳M
      REAL       RAIR                        !" CC̒萔
      REAL       EL                          !" ̋Ì̐M
      REAL       CPVAP                       !" C舳M
      REAL       RVAP                        !" CC̒萔
      REAL       DH2O                        !" ̖x
      REAL       EPSV                        !" ƑC̕qʔ
      REAL       ES0                         !" OOaCFo
      REAL       STB                         !" Stefan-Boltzman
      REAL       FKARM                       !" Karman 萔
      REAL       EPSVT                       !" 1/-1
*
      COMMON   /COMCON/
     &          ER    , GRAV  ,
     &          CP    , RAIR  ,
     &          EL    , CPVAP , RVAP  , DH2O  , EPSV  , ES0   ,
     &          STB   , FKARM , EPSVT
* 18 p2sfcm.F
*
*   [MODIFY] 
      REAL       UFLUX ( IDIM*JDIM, KMAX+1 ) !" դΥեå
      REAL       VFLUX ( IDIM*JDIM, KMAX+1 ) !" ֤Υեå
      REAL       TFLUX ( IDIM*JDIM, KMAX+1 ) !" ԤΥեå
      REAL       QFLUX ( IDIM*JDIM, KMAX+1 ) !" Υեå
*
      REAL       UMTXS ( IDIM*JDIM )             !" ɽ
      REAL       TMTXS ( IDIM*JDIM , 0:1, -1:1 ) !" Աɽ
      REAL       QMTXS ( IDIM*JDIM , 0:1, -1:1 ) !" 񱢲ɽ
*
*   [INPUT] 
      REAL       GDU   ( IDIM*JDIM, KMAX )   !"   
      REAL       GDV   ( IDIM*JDIM, KMAX )   !"   
      REAL       GDT   ( IDIM*JDIM, KMAX )   !"   
      REAL       GDTM  ( IDIM*JDIM, KMAX )   !" ١Ⱦ
      REAL       GDTG  ( IDIM*JDIM       )   !" ɽ̲
      REAL       GDQ   ( IDIM*JDIM, KMAX )   !" 漾  
      REAL       GDP   ( IDIM*JDIM, KMAX )   !" 
      REAL       GDPM  ( IDIM*JDIM, KMAX )   !" Ⱦ
      REAL       GDZ   ( IDIM*JDIM, KMAX )   !" 
*
      REAL       GRBET ( IDIM*JDIM )         !" ɽ٦
      REAL       GRZ0  ( IDIM*JDIM )         !" ɽĹ
      INTEGER    IDSFC ( IDIM*JDIM )         !" ɽ
*
*   [INTERNAL PARM] 
      REAL       P00, THS
      REAL       URMIN
      REAL       USMINM, USMINH, USMINE
      REAL       USMAXM, USMAXH, USMAXE
      DATA       P00   / 100000. /
      DATA       THS   / 300.    /            !" ܲ
      DATA       URMIN / 0.01    /            !" ңǾ
      DATA       USMINM/ 0.01    /            !" ưǾ
      DATA       USMINH/ 0.01    /            !" ǮǾ
      DATA       USMINE/ 0.01    /            !" Ǿ
      DATA       USMAXM/ 1000.   /            !" ư
      DATA       USMAXH/ 1000.   /            !" Ǯ
      DATA       USMAXE/ 1000.   /            !" 
*
      NAMELIST  /NMSFCM/ THS   , URMIN ,
     &                   USMINM, USMAXM,
     &                   USMINH, USMAXH,
     &                   USMINE, USMAXE
*
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE
*
*   [INTERNAL WORK] 
      COMMON    /COMWRK/
     &           EXNER , VABS  , RIB   ,
     &           CMV   , CHV   , CEV   ,
     &           QSAT  , DQSAT
      REAL       EXNER ( IDIM*JDIM )         !" 絤Exnerؿ
      REAL       VABS  ( IDIM*JDIM )         !" ®
      REAL       RIB   ( IDIM*JDIM )         !" Х륯ң
      REAL       CMV   ( IDIM*JDIM )         !" Х륯͢
      REAL       CHV   ( IDIM*JDIM )         !" Х륯͢
      REAL       CEV   ( IDIM*JDIM )         !" Х륯͢
      REAL       QSAT  ( IDIM*JDIM )         !" ɽ˰漾
      REAL       DQSAT ( IDIM*JDIM )         !" ɽ˰漾Ѳ
*
      INTEGER    IJ
      INTEGER    IFPAR, JFPAR
      REAL       AKAPPA
*
* 1 ..\include/zqsat.F
* PACKAGE ZQSAT     !" Clausis-Clapeyron ̎(֐)
*
*"    QSAT:  saturation water vapour mixing ratio
*"    DQSAT: d(QSAT)/d(T)
*
      REAL       FQSAT
      REAL       FDQSAT
      REAL       T, P, QS
*
      FQSAT ( T,P )    = EPSV * ES0
     &                   * EXP( EL/RVAP *( 1./273. - 1./T ) )
     &                   / P
      FDQSAT( T,QS )   = EL * QS / ( RVAP * T*T )
* 91 p2sfcm.F
*
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' SURFACE FLUX - P2.1a DATE=92/04/17'
         OFIRST = .FALSE.
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMSFCM, END=190 )
  190    WRITE  ( JFPAR, NMSFCM )
*
      ENDIF
*
      AKAPPA = RAIR / CP
      DO 100 IJ = 1, IDIM*JDIM
         EXNER ( IJ ) = ( GDP ( IJ,1 )/GDPM( IJ,1 ) ) ** AKAPPA
  100 CONTINUE
*
*"         < 1. Х륯ң >
*
      DO 1100 IJ = 1, IDIM*JDIM
         VABS ( IJ ) = SQRT( GDU( IJ,1 )**2+GDV( IJ,1 )**2 )
         RIB  ( IJ ) = GRAV / THS
     &                * (   GDT ( IJ,1 )/EXNER ( IJ ) 
     &                    - GDTG( IJ   )              )
     &                / MAX( VABS( IJ ), URMIN )**2 * GDZ( IJ,1 )
 1100 CONTINUE
*
*"         < 3. Х륯 >
*
      CALL BLKCOF
     O         ( CMV   , CHV   , CEV   ,
     I           RIB   , VABS  , GRZ0  , GRZ0  , GDZ   )
*
*"         < 4. Х륯͢ >
*
      DO 4100 IJ = 1, IDIM*JDIM
         CMV  ( IJ ) = CMV ( IJ )
     &                 * GDPM( IJ,1 ) / ( RAIR * GDTM( IJ,1 ) )
     &                 * MIN( MAX ( VABS( IJ ), USMINM ), USMAXM )
         CHV  ( IJ ) = CHV ( IJ )
     &                 * GDPM( IJ,1 ) / ( RAIR * GDTM( IJ,1 ) )
     &                 * MIN( MAX ( VABS( IJ ), USMINH ), USMAXH )
         CEV  ( IJ ) = CEV ( IJ )
     &                 * GDPM( IJ,1 ) / ( RAIR * GDTM( IJ,1 ) )
     &                 * MIN( MAX ( VABS( IJ ), USMINE ), USMAXE )
 4100 CONTINUE
*
*"         < 5. ˰漾  >
*
      DO 5100 IJ = 1, IDIM*JDIM
         QSAT ( IJ ) = FQSAT ( GDTG( IJ ), GDPM( IJ,1 ) )
         DQSAT( IJ ) = FDQSAT( GDTG( IJ ), QSAT( IJ )   )
 5100 CONTINUE
*
*"         < 6. եå >
*
      DO 6100 IJ = 1, IDIM*JDIM
         UFLUX( IJ,1 ) = UFLUX( IJ,1 )
     &                         - CMV ( IJ ) * GDU( IJ,1 )
         VFLUX( IJ,1 ) = VFLUX( IJ,1 )
     &                         - CMV ( IJ ) * GDV( IJ,1 )
         TFLUX( IJ,1 ) = TFLUX( IJ,1 )
     &                   + CP *  CHV ( IJ )
     &                        *(   GDTG( IJ )
     &                           - GDT ( IJ,1 )/EXNER ( IJ )   )
         QFLUX( IJ,1 ) = QFLUX( IJ,1 )
     &                   + EL *  CEV ( IJ ) * GRBET( IJ )
     &                        *( QSAT( IJ ) - GDQ ( IJ,1 ) )
 6100 CONTINUE
*
*"       < 7. ѹ >
*
      CALL RESET ( TMTXS, IDIM*JDIM*6 )
      CALL RESET ( QMTXS, IDIM*JDIM*6 )
*
      DO 7100 IJ = 1, IDIM*JDIM
         UMTXS( IJ )      =         CMV( IJ )
*
         TMTXS( IJ,1,0  ) =    CP * CHV( IJ ) / EXNER( IJ )
         TMTXS( IJ,0,1  ) =  - CP * CHV( IJ ) / EXNER( IJ )
*
         QMTXS( IJ,1,0  ) =    CP * CEV( IJ ) * GRBET( IJ )
         QMTXS( IJ,0,1  ) =  - CP * CEV( IJ ) * GRBET( IJ )
*
         IF ( IDSFC( IJ ) .GE. 1 ) THEN
*
            TMTXS( IJ,1,-1 ) = - CP * CHV( IJ )
            TMTXS( IJ,0,0  ) =   CP * CHV( IJ )
*
            QMTXS( IJ,1,-1 ) = - EL * CEV( IJ ) * GRBET( IJ )
     &                                          * DQSAT( IJ )
            QMTXS( IJ,0,0  ) =   EL * CEV( IJ ) * GRBET( IJ )
     &                                          * DQSAT( IJ )
         ENDIF
*
 7100 CONTINUE
*
      RETURN
      END
